// # # # included /home/smalkov/dev/Wafl/src/libExtern/integratedHeader.h
// # # # included /home/smalkov/dev/Wafl/src/libExtern/ExternLibInterface.h
#ifndef ExternLibInterfaceH
#define ExternLibInterfaceH
#include <vector>
// # # # included /home/smalkov/dev/Wafl/src/libExtern/../libCommon/Version.h
#ifndef SML_VersionH
#define SML_VersionH
// # # # included /home/smalkov/dev/Wafl/src/libCommon/../Settings/Settings.h
#ifndef SettingsH
#define SettingsH
// # # # included /home/smalkov/dev/Wafl/src/Settings/Settings_Constants.h
#ifndef SettingsConstantsH
#define SettingsConstantsH
#define WAFL_VER_WINDOWS        101
#define WAFL_VER_LINUX          102
#define WAFL_VER_MINGW          103
#define WAFL_VER_IIS            201
#define WAFL_VER_APACHE         202
#define WAFL_VER_BCB            301
#define WAFL_VER_MSVC           302
#define WAFL_VER_GCC            303
#define WAFL_VER_CLANG          304
#define WAFL_VER_ODBC_MS        401
#define WAFL_VER_ODBC_DB2CLI    402
#endif  
// # # # included /home/smalkov/dev/WaflLocal/bld/release/cmake_config.h
#ifndef cmake_configH
#define cmake_configH
#define WAFL_BUILD_HOST_SYSTEM                    Linux-5.13.0-30-generic
#define WAFL_BUILD_HOST_SYSTEM_NAME               Linux
#define WAFL_BUILD_HOST_SYSTEM_VERSION            5.13.0-30-generic
#define WAFL_BUILD_HOST_SYSTEM_PROCESSOR          x86_64
#define WAFL_BUILD_SYSTEM                         Linux-5.13.0-30-generic
#define WAFL_BUILD_SYSTEM_NAME                    Linux
#define WAFL_BUILD_SYSTEM_VERSION                 5.13.0-30-generic
#define WAFL_BUILD_SYSTEM_PROCESSOR               x86_64
#define CMAKE_GENERATOR                           Unix Makefiles
#define WAFL_BUILD_TARGET_LINUX                   1
#define WAFL_BUILD_PROJECT_NAME                   Wafl
#define PROJECT_NAME                              Wafl
#define PROJECT_NAME_STR                         "Wafl"
#define PROJECT_DESCRIPTION                       Wafl Project
#define PROJECT_DESCRIPTION_STR                  "Wafl Project"
#define PROJECT_VERSION_MAJOR_INT                 0
#define PROJECT_VERSION_MINOR_INT                 6
#define PROJECT_VERSION_PATCH_INT                 6
#define PROJECT_VERSION_MAJOR_STR                "0"
#define PROJECT_VERSION_MINOR_STR                "6"
#define PROJECT_VERSION_PATCH_STR                "6"
#define PROJECT_VERSION_TWEAK_STR                "22071"
#define PROJECT_VERSION                           0.6.6
#define PROJECT_VERSION_STR                      "0.6.6"
#define WAFL_BUILD_64BIT                          1
#define WAFL_BUILD_TYPE                           RELEASE
#define WAFL_BUILD_TYPE_STR                      "RELEASE"
#define WAFL_BUILD_TYPE_RELEASE                   1
#define WAFL_BUILD_HOME_DIRECTORY                 /home/smalkov/dev/Wafl/src
#define WAFL_BUILD_SOURCE_DIR                     /home/smalkov/dev/Wafl/src
#define WAFL_BUILD_BINARY_DIR                     /home/smalkov/dev/WaflLocal/bld/release
#define WAFL_BUILD_BINARY_DIR_STR                "/home/smalkov/dev/WaflLocal/bld/release"
#define WAFL_BUILD_CURRENT_BINARY_DIR             /home/smalkov/dev/WaflLocal/bld/release
#define WAFL_BUILD_CURRENT_BINARY_DIR_STR        "/home/smalkov/dev/WaflLocal/bld/release"
#define WAFL_BUILD_CXX_COMPILER                   /usr/bin/c++
#define WAFL_BUILD_CXX_COMPILER_ID                GNU
#define WAFL_BUILD_CXX_COMPILER_ID_STR           "GNU"
#define WAFL_BUILD_CXX_COMPILER_VERSION           9.3.0
#define WAFL_BUILD_CXX_COMPILER_VERSION_STR      "9.3.0"
#define WAFL_BUILD_UNIX                           1
#define WAFL_BUILD_VOID_PTR_SIZE                  8
#define WAFL_BUILD_PTR_INT                        long long
#define WAFL_BUILD_PTR_UINT                       unsigned long long
#define WAFL_BUILD_SIZEOF_SHORT                   2
#define WAFL_BUILD_SIZEOF_INT                     4
#define WAFL_BUILD_SIZEOF_LONG                    8
#define WAFL_BUILD_SIZEOF_LONGLONG                8
#define VER_RC_PRODUCT_NAME                      "Wafl Project"
#define VER_RC_PROJECT_VERSION                    0,6,6,22071
#define VER_RC_PROJECT_VERSION_STR               "0,6,6,22071"
#endif    
// # # # included /home/smalkov/dev/Wafl/src/Settings/Cmake_Settings.h
#ifndef SettingsCmakeH
#define SettingsCmakeH
#if defined(WAFL_BUILD_TARGET_WINDOWS)
#define WAFL_OS 						WAFL_VER_WINDOWS
#define WAFL_OS_WINDOWS					1
#if defined(WAFL_BUILD_TARGET_WINDOWS64)
#define WAFL_OS_WINDOWS64			1
#if !defined(_AMD64_)
#define _AMD64_
#endif
#elif defined(WAFL_BUILD_TARGET_WINDOWS32)
#define WAFL_OS_WINDOWS32			1
#if !defined(_X86_)
#define _X86_
#endif
#endif
#if defined(WAFL_BUILD_MSVC)
#define WAFL_COMPILER_MSVC			1
#define WAFL_COMPILER 				WAFL_VER_MSVC
#ifndef MSVC
#define MSVC			1
#endif
#elif defined(WAFL_BUILD_BORLAND)
#define WAFL_COMPILER_BCB			1
#define WAFL_COMPILER 				WAFL_VER_BCB
#ifndef __BORLANDC__
#define __BORLANDC__			1
#endif
#else
#error "Unknown compiler!"
#endif
#elif defined(WAFL_BUILD_TARGET_MINGW)
#define WAFL_OS 						WAFL_VER_MINGW
#define WAFL_OS_MINGW					1
#define WAFL_WEB_SERVER 				WAFL_VER_APACHE
#define WAFL_COMPILER_GCC				1
#define WAFL_COMPILER 					WAFL_VER_GCC
#if !defined(WAFL_BUILD_MINGW)
#error "Not consistant compiler settings!"
#endif
#if defined(__MINGW64__)
#if !defined(WAFL_BUILD_MINGW64) || defined(WAFL_BUILD_MINGW32)
#error "Not consistant compiler settings!"
#endif
#elif defined(__MINGW32__)
#if !defined(WAFL_BUILD_MINGW32) || defined(WAFL_BUILD_MINGW64)
#error "Not consistant compiler settings!"
#endif
#else
#error "Unknown compiler!"
#endif
#elif defined(WAFL_BUILD_TARGET_LINUX)
#define WAFL_OS 						WAFL_VER_LINUX
#define WAFL_OS_LINUX					1
#define WAFL_WEB_SERVER 				WAFL_VER_APACHE
#if defined(__clang__)
#define WAFL_COMPILER_CLANG			1
#define WAFL_COMPILER 				WAFL_VER_CLANG
#elif defined(__GNUC__)
#define WAFL_COMPILER_GCC			1
#define WAFL_COMPILER 				WAFL_VER_GCC
#else
#error "Unknown compiler!"
#endif
#else
#error "Unknown target platform!"
#endif
constexpr short unsigned t_Wafl_Ptr_Size = WAFL_BUILD_VOID_PTR_SIZE;
constexpr short unsigned t_Wafl_Word_Size = WAFL_BUILD_VOID_PTR_SIZE;
constexpr short unsigned t_Wafl_Word_Size_Bits = WAFL_BUILD_VOID_PTR_SIZE * 8;
using t_Wafl_Signed_Word = WAFL_BUILD_PTR_INT;
using t_Wafl_Word = WAFL_BUILD_PTR_UINT;
#if defined(WAFL_BUILD_64BIT)
#define WAFL_OS_64BIT
#define WAFL_WORD_SIZE 64
#define WAFL_WORD_SIZE_64 1
#else
#define WAFL_OS_32BIT
#define WAFL_WORD_SIZE 32
#define WAFL_WORD_SIZE_32 1
#endif
#endif  
// # # # included /home/smalkov/dev/Wafl/src/Settings/Build_Options.h
#ifndef SettingsOptionsH
#define SettingsOptionsH
#define ENABLE_EXCEPTION_HANDLING_DISABLING
#ifdef WAFL_BUILD_TYPE_DEBUG
#define DEBUG_OBJECT_COUNT_ON 1
#ifdef DEBUG_OBJECT_COUNT_ON
#define DEBUG_SMSTRING_COUNT_ON 1
#define DEBUG_DATATYPE_COUNT_ON 1
#define DEBUG_EXPRESSIONS_COUNT_ON 1
#endif	
#define DEBUG_ENABLE_TRACE
#ifdef DEBUG_ENABLE_TRACE
#endif
#define DEBUG_ENABLE_SMLIB_MEMORY_TRACKING 1
#define DEBUG_ENABLE_EXPRESSIONS_ALLOC_TRACKING 1
#endif		
#define DISABLE_CONNECTING_TO_DATABASE_UNTIL_FIRST_USE
#define WAFL_STRING_USES_BASIC_STRING
#define DISABLE_LAZY_STRINGS
#define WAFL_KL_ENGLISH 0
#define WAFL_KL_SERBIAN 1
#define WAFL_SYNTAX_KEYWORDS_LANGUAGE WAFL_KL_ENGLISH
// # # # included /home/smalkov/dev/Wafl/src/Settings/Options_Syntax_Keywords.h
#ifndef Settings_Options_SyntaxKeywords_H
#define Settings_Options_SyntaxKeywords_H
#if WAFL_SYNTAX_KEYWORDS_LANGUAGE == WAFL_KL_SERBIAN
#define WAFL_KEYWORD_cached         "cached"
#define WAFL_KEYWORD_case           "slučaj"
#define WAFL_KEYWORD_default        "podrazumevano"
#define WAFL_KEYWORD_else           "inače"
#define WAFL_KEYWORD_extern         "spoljašnja"
#define WAFL_KEYWORD_file           "datoteka"
#define WAFL_KEYWORD_function       "funkcija"
#define WAFL_KEYWORD_function_file  "funkcijska"
#define WAFL_KEYWORD_if             "ako"
#define WAFL_KEYWORD_lambda         "lambda"
#define WAFL_KEYWORD_library        "biblioteka"
#define WAFL_KEYWORD_library_file   "bibliotečka"
#define WAFL_KEYWORD_query          "upit"
#define WAFL_KEYWORD_reset          "poništi"
#define WAFL_KEYWORD_set            "postavi"
#define WAFL_KEYWORD_switch         "prema"
#define WAFL_KEYWORD_template       "šablon"
#define WAFL_KEYWORD_then           "onda"
#define WAFL_KEYWORD_transaction    "transakcija"
#define WAFL_KEYWORD_typed          "tipiziran"
#define WAFL_KEYWORD_untyped        "netipiziran"
#define WAFL_KEYWORD_where          "gde"
#else
#define WAFL_KEYWORD_cached         "cached"
#define WAFL_KEYWORD_case           "case"
#define WAFL_KEYWORD_default        "default"
#define WAFL_KEYWORD_else           "else"
#define WAFL_KEYWORD_extern         "extern"
#define WAFL_KEYWORD_file           "file"
#define WAFL_KEYWORD_function       "function"
#define WAFL_KEYWORD_function_file  "function"
#define WAFL_KEYWORD_if             "if"
#define WAFL_KEYWORD_lambda         "lambda"
#define WAFL_KEYWORD_library        "library"
#define WAFL_KEYWORD_library_file   "library"
#define WAFL_KEYWORD_query          "query"
#define WAFL_KEYWORD_reset          "reset"
#define WAFL_KEYWORD_set            "set"
#define WAFL_KEYWORD_switch         "switch"
#define WAFL_KEYWORD_template       "template"
#define WAFL_KEYWORD_then           "then"
#define WAFL_KEYWORD_transaction    "transaction"
#define WAFL_KEYWORD_typed          "typed"
#define WAFL_KEYWORD_untyped        "untyped"
#define WAFL_KEYWORD_where          "where"
#endif
#endif  
// # # # included /home/smalkov/dev/Wafl/src/Settings/Options_Syntax_v0_5.h
#ifndef Settings_Options_ParserLegacyV0_5_H
#define Settings_Options_ParserLegacyV0_5_H
#define WAFL_SYNTAX_DOT_FUNCTION_OPERATOR1 'C'
#define WAFL_SYNTAX_DOT_FUNCTION_OPERATOR2 '.'
#define WAFL_SYNTAX_RECORD_SELECTOR_OPERATOR '$'
#define WAFL_SYNTAX_RECORD_UPDATE_SELECTOR_OPERATOR '^'
#endif  
#endif  
// # # # included /home/smalkov/dev/Wafl/src/Settings/OS_Settings.h
#ifndef SettingsOsH
#define SettingsOsH
#if WAFL_OS == WAFL_VER_WINDOWS
#define WAFL_EXPORT extern "C" __declspec(dllexport)
#define WAFL_NOINLINE __declspec(noinline)
#elif WAFL_OS == WAFL_VER_LINUX
#define WAFL_EXPORT extern "C"
#define WAFL_NOINLINE __attribute__ ((noinline))
#elif WAFL_OS == WAFL_VER_MINGW
#define WAFL_EXPORT extern "C"
#define WAFL_NOINLINE __attribute__ ((noinline))
#else
#error "Unsupported operating system!"
#endif
#endif  
// # # # included /home/smalkov/dev/Wafl/src/Settings/Compiler_Settings.h
#ifndef SettingsCompilerH
#define SettingsCompilerH
#if WAFL_COMPILER == WAFL_VER_MSVC
// # # # included /home/smalkov/dev/Wafl/src/Settings/Compiler_Settings_msvc.h
#ifndef SettingsCompiler_MSVC_H
#define SettingsCompiler_MSVC_H
#if WAFL_COMPILER == WAFL_VER_MSVC
#define WAFL_SUPPORTED_STACK_SAVER
#define WAFL_DEFAULT_STACK_SAVER
#define strncasecmp(x,y,n) _strnicmp(x,y,n)
#define strcasecmp(x,y) _stricmp(x,y)
#endif	
#endif  
#ifndef DISABLE_LAZY_STRINGS
#define WAFL_EVALUATOR_USING_LAZY_STRINGS
#else
#undef WAFL_EVALUATOR_USING_LAZY_STRINGS
#endif
#elif WAFL_COMPILER == WAFL_VER_GCC
// # # # included /home/smalkov/dev/Wafl/src/Settings/Compiler_Settings_gcc.h
#ifndef SettingsCompiler_GCC_H
#define SettingsCompiler_GCC_H
#if WAFL_COMPILER == WAFL_VER_GCC
#define WAFL_SUPPORTED_STACK_SAVER
#define WAFL_DEFAULT_STACK_SAVER
#if WAFL_OS == WAFL_VER_MINGW
#ifndef __fastcall
#define __fastcall	__attribute__((fastcall))
#endif
#else	
typedef long long __int64;
#ifndef __fastcall
#define __fastcall
#endif
#endif	
#endif	
#endif  
#undef WAFL_EVALUATOR_USING_LAZY_STRINGS
#elif WAFL_COMPILER == WAFL_VER_CLANG
// # # # included /home/smalkov/dev/Wafl/src/Settings/Compiler_Settings_clang.h
#ifndef SettingsCompiler_CLANG_H
#define SettingsCompiler_CLANG_H
#if WAFL_COMPILER == WAFL_VER_CLANG
#define WAFL_SUPPORTED_STACK_SAVER
#define WAFL_DEFAULT_STACK_SAVER
#if WAFL_OS == WAFL_VER_MINGW
#ifndef __fastcall
#define __fastcall	__attribute__((fastcall))
#endif
#else	
#ifndef __fastcall
#define __fastcall
#endif
#endif	
#endif	
#endif  
#undef WAFL_EVALUATOR_USING_LAZY_STRINGS
#else
#error "Unsupported compiler!"
#endif
#endif  
// # # # included /home/smalkov/dev/Wafl/src/Settings/Check_Options.h
#ifndef Settings_CheckOptionsH
#define Settings_CheckOptionsH
#if WAFL_OS==WAFL_VER_WINDOWS
#if !defined(WAFL_OS_WINDOWS) || defined(WAFL_OS_LINUX) || defined(WAFL_OS_MINGW)
#error "Unconsistent settings!"
#endif
#elif WAFL_OS==WAFL_VER_LINUX
#if defined(WAFL_OS_WINDOWS) || !defined(WAFL_OS_LINUX) || defined(WAFL_OS_MINGW)
#error "Unconsistent settings!"
#endif
#elif WAFL_OS == WAFL_VER_MINGW
#if defined(WAFL_OS_WINDOWS) || defined(WAFL_OS_LINUX) || !defined(WAFL_OS_MINGW)
#error "Unconsistent settings!"
#endif
#else
#error "Unsupported operating system!"
#endif
#if WAFL_COMPILER == WAFL_VER_BCB
#ifndef __BORLANDC__
#error "Expected Borland Compiler!"
#endif
#elif WAFL_COMPILER == WAFL_VER_GCC
#ifndef __GNUG__
#error "Expected GNU C++ Compiler!"
#endif
#elif WAFL_COMPILER == WAFL_VER_CLANG
#elif WAFL_COMPILER == WAFL_VER_MSVC
#else
#error "Compiler is not defined!"
#endif
#endif  
#endif  
#include <string>
#include <sstream>
#include <set>
#include <map>
namespace sml {
class VersionNumber
{
public:
VersionNumber(
unsigned major = PROJECT_VERSION_MAJOR_INT,
unsigned minor = PROJECT_VERSION_MINOR_INT,
unsigned patch = PROJECT_VERSION_PATCH_INT,
const char* tweak = PROJECT_VERSION_TWEAK_STR
)
: VerMajor_( major ),
VerMinor_( minor ),
VerPatch_( patch ),
VerTweak_( tweak ? tweak : "" )
{
std::ostringstream ostr;
ostr << VerMajor_ << '.' << VerMinor_ << '.' << VerPatch_;
ProjectVersionStr_ = ostr.str();
}
const std::string& VersionString() const
{
return ProjectVersionStr_;
}
const char* VersionTweakString() const
{ return VerTweak_; }
bool operator == ( const VersionNumber& v ) const
{
return VerMajor_ == v.VerMajor_
&& VerMinor_ == v.VerMinor_
&& VerPatch_ == v.VerPatch_;
}
bool operator != ( const VersionNumber& v ) const
{
return !( *this == v );
}
bool operator < ( const VersionNumber& v ) const
{
return
VerMajor_ < v.VerMajor_ ||
( VerMajor_ == v.VerMajor_ && (
VerMinor_ < v.VerMinor_ ||
( VerMinor_ == v.VerMinor_ && VerPatch_ < v.VerPatch_ )
)
);
}
bool operator > ( const VersionNumber& v ) const
{
return v < *this;
}
bool operator <= ( const VersionNumber& v ) const
{
return !( v < *this );
}
bool operator >= ( const VersionNumber& v ) const
{
return !( *this < v );
}
private:
unsigned		VerMajor_, VerMinor_, VerPatch_;	
const char*		VerTweak_;							
std::string		ProjectVersionStr_;					
};
class ModuleVersionInfo
{
public:
static ModuleVersionInfo& Instance() {
static ModuleVersionInfo version;
return version;
}
void RegisterVersionInfo( const std::string& category, const std::string& desc );
void RegisterUniqueVersionInfo( const std::string& category, const std::string& desc );
bool CheckVersionInfo( const std::string& category, const std::string& desc ) const;
const std::string& GetVersionString( const std::string& key ) const;
const std::string& GetVersionString( const std::string& key, const std::string& def ) const;
const std::string& ModuleName() const;
const VersionNumber& GetVersion() const
{ return VersionNumber_; }
const std::string& GetCompactVersionDescription() const;
const std::string& GetVerboseVersionDescription() const;
const std::string& GetVersionDescription( bool verbose ) const
{
return verbose
? GetVerboseVersionDescription()
: GetCompactVersionDescription();
}
const char* CmakeProjectDescription() const
{ return PROJECT_DESCRIPTION_STR; }
const char* CmakeBuildType() const
{ return WAFL_BUILD_TYPE_STR; }
const char* CmakeCompilerId() const
{ return WAFL_BUILD_CXX_COMPILER_ID_STR; }
const char* CmakeCompilerVersion() const
{ return WAFL_BUILD_CXX_COMPILER_VERSION_STR; }
static const std::string& key_ModuleName();
static const std::string& key_Option();
static const std::string& key_ExperimentalNote();
private:
ModuleVersionInfo()
: VersionNumber_()
{}
VersionNumber									VersionNumber_;			
std::map<std::string, std::set<std::string>>	VersionInfoAttrs_;		
std::map<std::string, std::string>				VersionInfoString_;		
mutable std::string								CompactVersionString_;	
mutable std::string								VerboseVersionString_;	
public:
class AddInfo
{
public:
AddInfo( const std::string& cat, const std::string& desc )
{ ModuleVersionInfo::Instance().RegisterVersionInfo( cat, desc ); }
};
class AddOption : public AddInfo
{
public:
AddOption( const std::string& option )
: AddInfo( ModuleVersionInfo::key_Option(), option )
{}
};
class AddExperimentalNote : public AddInfo
{
public:
AddExperimentalNote( const std::string& option )
: AddInfo( ModuleVersionInfo::key_ExperimentalNote(), option )
{}
};
class AddUniqueInfo
{
public:
AddUniqueInfo( const std::string& cat, const std::string& desc )
{ ModuleVersionInfo::Instance().RegisterUniqueVersionInfo( cat, desc ); }
};
class SetModuleName : public AddUniqueInfo
{
public:
SetModuleName( const std::string& modulename )
: AddUniqueInfo( ModuleVersionInfo::key_ModuleName(), modulename )
{}
};
};
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libExtern/../libCommon/smString.h
#ifndef SML_StringH
#define SML_StringH
// # # # included /home/smalkov/dev/Wafl/src/libCommon/Char.h
#ifndef SML_CharH
#define SML_CharH
namespace sml {
class Char
{
public:
static inline bool isSpaceOrInvisible( char c )
{   return c>=0 && c<33;    }
static inline bool isLCaseAsciiLetter( char c )
{   return c>='a' && c<='z';    }
static inline bool isUCaseAsciiLetter( char c )
{   return c>='A' && c<='Z';    }
static inline bool isAsciiLetter( char c )
{ return isLCaseAsciiLetter(c) || isUCaseAsciiLetter(c); }
static inline bool isNameStartChar( char c )
{   return isAsciiLetter(c) || c=='_';   }
static inline bool isNameChar( char c )
{   return isNameStartChar(c) || isDecDigit(c);    }
static inline bool isDecDigit( char c )
{ return c >= '0' && c <= '9'; }
static inline bool isHexDigit( char c )
{
return ( c >= '0' && c <= '9' )
|| ( c >= 'a' && c <= 'f' )
|| ( c >= 'A' && c <= 'F' );
}
static inline bool isAsciiLetterOrDecDigit( char c )
{ return isAsciiLetter( c ) || isDecDigit( c ); }
static inline short hexValue( char x )
{ return (short)( ( x >= 'A' ) ? ( x & 0x07 ) + 9 : x - '0' ); }
static inline short hexValue( char x, char y )
{ return (short)( ( hexValue( x ) << 4 ) + hexValue( y ) ); }
static inline char hexDigit( char c )
{ return (char)( c<10 ? '0' + c : 'A' + c - 10 ); }
static inline char decDigit( char c )
{ return char( '0' + c ); }
};
}   
#endif  
#if WAFL_OS == WAFL_VER_LINUX || WAFL_OS == WAFL_VER_MINGW
#endif
#if !defined(WAFL_STRING_USES_BASIC_STRING) && !defined(WAFL_STRING_USES_RC_BASIC_STRING)
#error "Not defined String implementation!"
#endif
#if defined(WAFL_STRING_USES_BASIC_STRING)
// # # # included /home/smalkov/dev/Wafl/src/libCommon/smString_STL.h
#ifndef SML_String_StlH
#define SML_String_StlH
#ifndef SML_StringH
#error	Header smStringSTL.h has to be included in smString.h!
#endif
#if !defined(WAFL_STRING_USES_BASIC_STRING)
#error "Require appropriate context!"
#endif
// # # # included /home/smalkov/dev/Wafl/src/libCommon/DbgObjCount.h
#ifndef SML_DebugObjCountH
#define SML_DebugObjCountH
#include <sstream>
namespace sml {
template< typename C >
class DebugObjectCounter
{
public:
static std::string __objCounter_Description() {
std::ostringstream ostr;
ostr << "[ "
<< __get_ConstructorCount() << " : "
<< __get_CopyConstructorCount() << " : "
<< __get_MoveConstructorCount() << " : "
<< __get_DestructorCount() << " : "
<< __get_CopyAssignmentCount() << " : "
<< __get_MoveAssignmentCount() << " ]";
return ostr.str();
}
#ifdef DEBUG_OBJECT_COUNT_ON
protected:
DebugObjectCounter() {
__inc_ConstructorCount();
}
DebugObjectCounter( const DebugObjectCounter& ) {
__inc_CopyConstructorCount();
}
DebugObjectCounter( DebugObjectCounter&& ) noexcept {
__inc_MoveConstructorCount();
}
~DebugObjectCounter() {
__inc_DestructorCount();
}
void operator = ( const DebugObjectCounter& ) {
__inc_CopyAssignmentCount();
}
void operator = ( DebugObjectCounter&& ) noexcept {
__inc_MoveAssignmentCount();
}
public:
static void __resetCounters() {
__getObjectCounterData().ResetCounters();
}
static unsigned __get_ConstructorCount() { return __getObjectCounterData().ConstructorCount; }
static unsigned __get_CopyConstructorCount() { return __getObjectCounterData().CopyConstructorCount; }
static unsigned __get_MoveConstructorCount() { return __getObjectCounterData().MoveConstructorCount; }
static unsigned __get_DestructorCount() { return __getObjectCounterData().DestructorCount; }
static unsigned __get_CopyAssignmentCount() { return __getObjectCounterData().CopyAssignmentCount; }
static unsigned __get_MoveAssignmentCount() { return __getObjectCounterData().MoveAssignmentCount; }
static unsigned __get_AliveObjectsCount() { return __getObjectCounterData().AliveObjectsCount(); }
protected:
static void __inc_ConstructorCount() { __getObjectCounterData().ConstructorCount++; }
static void __inc_CopyConstructorCount() { __getObjectCounterData().CopyConstructorCount++; }
static void __inc_MoveConstructorCount() { __getObjectCounterData().MoveConstructorCount++; }
static void __inc_DestructorCount() { __getObjectCounterData().DestructorCount++; }
static void __inc_CopyAssignmentCount() { __getObjectCounterData().CopyAssignmentCount++; }
static void __inc_MoveAssignmentCount() { __getObjectCounterData().MoveAssignmentCount++; }
#else
public:
static void __resetCounters() {}
static unsigned __get_ConstructorCount() { return 0; }
static unsigned __get_CopyConstructorCount() { return 0; }
static unsigned __get_MoveConstructorCount() { return 0; }
static unsigned __get_DestructorCount() { return 0; }
static unsigned __get_CopyAssignmentCount() { return 0; }
static unsigned __get_MoveAssignmentCount() { return 0; }
protected:
static void __inc_ConstructorCount() {}
static void __inc_CopyConstructorCount() {}
static void __inc_MoveConstructorCount() {}
static void __inc_DestructorCount() {}
static void __inc_CopyAssignmentCount() {}
static void __inc_MoveAssignmentCount() {}
#endif
private:
struct CounterData {
unsigned ConstructorCount;
unsigned CopyConstructorCount;
unsigned MoveConstructorCount;
unsigned DestructorCount;
unsigned CopyAssignmentCount;
unsigned MoveAssignmentCount;
void ResetCounters() {
ConstructorCount = CopyConstructorCount = MoveConstructorCount
= DestructorCount
= CopyAssignmentCount = MoveAssignmentCount
= 0;
}
unsigned AliveObjectsCount() {
return ConstructorCount + CopyConstructorCount + MoveConstructorCount - DestructorCount;
}
};
static CounterData& __getObjectCounterData() {
static CounterData data_;
return data_;
}
};
}   
#endif  
#include <cstring>
#include <string>
namespace sml {
#ifdef ENABLE_EXCEPTION_HANDLING_DISABLING
#endif
class smStdString
#ifdef DEBUG_SMSTRING_COUNT_ON
: public DebugObjectCounter<smStdString>
#endif
{
public:
using size_type = std::string::size_type;
static constexpr size_type npos = std::string::npos;
class tBaseString : public std::string
#ifdef DEBUG_SMSTRING_COUNT_ON
, public DebugObjectCounter<tBaseString>
#endif
{
public:
tBaseString()
: std::string()
{}
tBaseString( const char* s )
: std::string()
{
if(s)
assign(s);
}
tBaseString( const char* s, size_type n )
: std::string(s,n)
{}
tBaseString( size_type n, char c )
: std::string(n,c)
{}
tBaseString( const std::string& s )
: std::string( s )
#ifdef DEBUG_SMSTRING_COUNT_ON
, DebugObjectCounter( *this )
#endif
{}
tBaseString( std::string&& s )
: std::string( std::move( s ) )
#ifdef DEBUG_SMSTRING_COUNT_ON
, DebugObjectCounter( std::move( *this ) )
#endif
{}
tBaseString( const tBaseString& s )
: std::string(s)
#ifdef DEBUG_SMSTRING_COUNT_ON
, DebugObjectCounter( *this )
#endif
{
*(t_Wafl_Word*)this = *(t_Wafl_Word*)&s;
}
virtual tBaseString* makeACopy() const
{ return new tBaseString( *this ); }
virtual void resize( size_type n )
{ std::string::resize( n ); }
virtual void reserve( size_type n )
{ std::string::reserve( n ); }
virtual ~tBaseString()
{}
private:
tBaseString& operator = ( const tBaseString& ) = delete;
tBaseString& operator = ( const std::string& ) = delete;
tBaseString& operator = ( tBaseString&& ) = delete;
tBaseString& operator = ( std::string&& ) = delete;
};
public:
smStdString()
: Data( newStringData() )
{}
smStdString( char c )
: Data( newStringData(1,c) )
{}
smStdString( size_type n, char c )
: Data( newStringData(n,c) )
{}
smStdString( const char* s )
: Data( newStringData(s) )
{}
smStdString( const char* s, size_type len )
: Data( newStringData(s,len) )
{}
explicit smStdString( const tBaseString& s )
: Data( newStringData(s) )
{}
smStdString( short n );
smStdString( unsigned short n );
smStdString( int n );
smStdString( unsigned int n );
smStdString( long n );
smStdString( unsigned long n );
smStdString( long long n );
smStdString( unsigned long long n );
smStdString( float f );
smStdString( double d );
smStdString( double d, char decimalPoint );
smStdString( double d, int dec );
smStdString( double d, char decimalPoint, bool force );
explicit smStdString( const void* p );
explicit smStdString( bool b )
: Data( newStringData( b ? "true" : "false" ))
{}
~smStdString()
{ delete Data; }
smStdString( const smStdString& str )
: Data( newStringData( *str.Data ) )
#ifdef DEBUG_SMSTRING_COUNT_ON
, DebugObjectCounter<smStdString>( *this )
#endif
{}
smStdString( smStdString&& str ) noexcept
: Data( str.Data )
#ifdef DEBUG_SMSTRING_COUNT_ON
, DebugObjectCounter<smStdString>( std::move(str) )
#endif
{ str.Data = nullptr; }
void swap( smStdString& s )
{ std::swap( Data, s.Data ); }
friend void swap( smStdString& s1, smStdString& s2 )
{ s1.swap( s2 ); }
smStdString& operator = ( const smStdString& str )
{
#ifdef DEBUG_SMSTRING_COUNT_ON
DebugObjectCounter<smStdString>::operator=( str );
#endif
smStdString tmp( str );
swap( tmp );
return *this;
}
smStdString& operator = ( smStdString&& str ) noexcept
{
#ifdef DEBUG_SMSTRING_COUNT_ON
DebugObjectCounter<smStdString>::operator=( std::move(str) );
#endif
swap( str );
return *this;
}
smStdString& operator = ( const char* s )
{
if( s != c_str() ){
delete Data;
Data = newStringData(s);
}
return *this;
}
smStdString& operator += ( const smStdString& str )
{
if(!str.IsNull())
concatSubStr( str, 0, str.length() );
else
concat("Null");
return *this;
}
smStdString& operator += ( const char* s )
{
if(s) concat(s);
return *this;
}
smStdString& operator += ( char c )
{
size_type oldlen = length();
Data->resize( oldlen + 1 );
const_cast<char*>( Data->c_str() )[oldlen] = c;
return *this;
}
template<typename T>
smStdString& operator += ( const T& x )
{
return operator+=( smStdString( x ) );
}
friend smStdString operator + ( smStdString s1, const smStdString& s2 )
{
s1 += s2;
return s1;
}
smStdString operator + ( const char* str ) const
{
smStdString res = *this;
res += str;
return res;
}
void concatSubStr( const smStdString& s, size_type pos, size_type len );
void concat( const char* s );
bool empty() const
{ return Data->empty(); }
size_type length() const
{ return Data->length(); }
size_type size() const
{ return length(); }
smStdString subStr( size_type index, size_type count ) const
{ return Data->substr( index, count ); }
smStdString substr( size_type index, size_type count ) const
{ return subStr( index, count ); }
void clear()
{ Data->clear(); }
smStdString strLeft( size_type count ) const
{ return subStr( 0, count ); }
smStdString strRight( size_type count ) const
{
size_type len = length();
return count < len
? subStr(len - count, count)
: *this;
}
smStdString strRightFrom(size_type pos) const
{
size_type len = length();
return pos < len
? subStr( pos, len - pos )
: smStdString("");
}
smStdString strLTrim() const;
smStdString strRTrim() const;
smStdString strTrim() const;
bool beginsWith( const smStdString& s ) const
{ return !strncmp( c_str(), s.c_str(), s.length() ); }
bool beginsWith( const char* s ) const
{ return !strncmp( c_str(), s, strlen(s) ); }
bool endsWith( const smStdString& s ) const
{
size_t len = length();
size_t slen = s.length();
return len >= slen && !strncmp( c_str() + len - slen, s.c_str(), slen );
}
bool endsWith( const char* s ) const
{
size_t len = length();
size_t slen = strlen( s );
return len >= slen && !strncmp( c_str() + len - slen, s, slen );
}
size_type pos( const smStdString& s ) const
{ return Data->find(*s.Data); }
size_type nextPos( const smStdString& s, size_type from ) const
{ return Data->find( *s.Data, from + 1 ); }
size_type lastPos( const smStdString& s ) const
{ return Data->rfind( *s.Data ); }
size_type nextLastPos( const smStdString& s, size_type from ) const
{ return Data->rfind( *s.Data, from - 1 ); }
size_type posI( const smStdString& s ) const
{ return nextPosI( s, npos ); }
size_type nextPosI( const smStdString& s, size_type from ) const;
size_type lastPosI( const smStdString& s ) const
{ return nextLastPosI( s, npos ); }
size_type nextLastPosI( const smStdString& s, size_type from ) const;
size_type findFirstOf( const smStdString& s, size_type pos=npos ) const;
smStdString replace( const smStdString& s, const smStdString& d, size_type n ) const;
smStdString replaceAll( const smStdString& s, const smStdString& d ) const;
smStdString replaceI( const smStdString& s, const smStdString& d, size_type n ) const;
smStdString replaceAllI( const smStdString& s, const smStdString& d ) const;
size_type countSub( const smStdString&s, bool disjunctOnly = false ) const;
size_type countSubI( const smStdString&s, bool disjunctOnly = false ) const;
smStdString insert( const smStdString& s, size_type pos=0 ) const;
smStdString insert( const char* s, size_type pos=0 ) const;
smStdString lowerCase() const;
smStdString upperCase() const;
smStdString reverse() const;
const char* c_str() const
{ return Data->c_str(); }
char* c_str()
{ return const_cast<char*>(Data->c_str()); }
const std::string& str() const
{ return *Data; }
std::string& str()
{ return *Data; }
long asInt32() const;
long asInt32( long def ) const;
t_Wafl_Signed_Word asInt() const;
t_Wafl_Signed_Word asInt( t_Wafl_Signed_Word def ) const;
double asFloat() const;
double asFloat( double def ) const;
bool asBool() const
{ return (*this)=="true" || (*this)=="T"; }
const std::string& asStdString() const
{ return *Data; }
const tBaseString& asBaseString() const
{ return *Data; }
const smStdString& asString() const
{ return (*this); }
smStdString EncodeUrlQuery() const;
smStdString DecodeUrlQuery() const;
smStdString EncodeHtmlText() const;
smStdString EncodeSqlString() const;
smStdString EncodeCString() const;
smStdString EncodeWaflString() const
{ return EncodeCString(); }
smStdString EncodeWaflStringWithQuotes( char quote='\'' ) const
{ return smStdString(quote) + EncodeWaflString() + quote; }
char operator[] ( size_type n ) const
{
return n<size()
? (*Data)[n]
: '\0';
}
char& operator[] ( size_type n )
{
return n<size()
? (*Data)[n]
: (DummyChar = '\0');
}
void resize( size_type n )
{ Data->resize( n ); }
void reserve( size_type n )
{ Data->reserve( n ); }
size_t capacity() const
{ return Data->capacity(); }
bool operator == ( const char* txt ) const
{ return !IsNull() && txt && !strcmp( Data->c_str(), txt ); }
bool operator == ( const smStdString& s ) const
{ return ( *Data == *s.Data && !IsNull() && !s.IsNull() ) || ( IsNull() && s.IsNull() ); }
bool operator != ( const char* txt ) const
{ return IsNull() || txt && strcmp( Data->c_str(), txt ); }
bool operator != ( const smStdString& s) const
{ return *Data != *s.Data; }
bool operator < ( const smStdString& s ) const
{ return *Data < *s.Data; }
bool operator <= ( const smStdString& s ) const
{ return *Data <= *s.Data; }
bool operator > ( const smStdString& s ) const
{ return *Data > *s.Data; }
bool operator >= ( const smStdString& s ) const
{ return *Data >= *s.Data; }
short Compare( const smStdString& s ) const
{ return Data->compare( *s.Data ); }
static const smStdString& NullString()
{
static const smStdString nullString( "NULL\0NULL\0", 10 );
return nullString;
}
bool IsNull() const
{
return
Data->c_str() == NullString().Data->c_str()
|| ( length() == 10 && !memcmp( c_str(), NullString().c_str(), 10 ) );
}
void __Instantiate() const
{ const_cast<tBaseString*&>(Data) = newStringData(*Data); }
void __Deinstantiate() const
{
delete Data;
Data = nullptr;
}
private:
smStdString( const std::string& s )
: Data( newStringData(s) )
{}
mutable tBaseString* Data;
static tBaseString* newStringData();
static tBaseString* newStringData( const char* s );
static tBaseString* newStringData( const char* s, size_type len );
static tBaseString* newStringData( const tBaseString& s );
static tBaseString* newStringData( size_type n, char c );
public:
static char DummyChar;
};
inline std::ostream& operator << ( std::ostream& ostr, const smStdString& str )
{ return ostr << str.str(); }
inline std::istream& operator >> ( std::istream& istr, smStdString& str )
{ return istr >> str.str(); }
#ifdef ENABLE_EXCEPTION_HANDLING_DISABLING
#endif
}   
#endif  
namespace sml {
using String = smStdString;
}
#elif defined(WAFL_STRING_USES_RC_BASIC_STRING)
// # # # included /home/smalkov/dev/Wafl/src/libCommon/smString_RCSTL.h
#ifndef SML_String_RcStlH
#define SML_String_RcStlH
#ifndef SML_StringH
#error "smStringRCSTL.h header has to be included in smString.h"
#endif
#if !defined(WAFL_STRING_USES_RC_BASIC_STRING)
#error "Require appropriate context!"
#endif
!!! NOT UPDATED, PLEASE USE BASIC STRINGS
#include <string>
namespace sml {
#ifdef ENABLE_EXCEPTION_HANDLING_DISABLING
#endif
NOT UPDATED!!!
contains old String class definition!!!
class String : public RCPointer<string>
{
public:
String()
: RCPointer<string>( new string )
{}
String( char c )
: RCPointer<string>( new string )
{ *Object() = c; }
String( const char* s )
: RCPointer<string>( new string(s) )
{}
String( const string& s )
: RCPointer<string>( new string(s) )
{}
String( short n )
: RCPointer<string>( new string )
{
char buf[10];
sprintf( buf, "%hd", n );
*Object() = buf;
}
String( unsigned short n )
: RCPointer<string>( new string )
{
char buf[10];
sprintf( buf, "%hu", n );
*Object() = buf;
}
String( int n )
: RCPointer<string>( new string )
{
char buf[20];
sprintf( buf, "%d", n );
*Object() = buf;
}
String( unsigned int n )
: RCPointer<string>( new string )
{
char buf[20];
sprintf( buf, "%u", n );
*Object() = buf;
}
String( long n )
: RCPointer<string>( new string )
{
char buf[20];
sprintf( buf, "%ld", n );
*Object() = buf;
}
String( unsigned long n )
: RCPointer<string>( new string )
{
char buf[20];
sprintf( buf, "%lu", n );
*Object() = buf;
}
String( double d )
: RCPointer<string>( new string )
{
char buf[20];
sprintf( buf, "%f", d );
*Object() = buf;
}
String( int count, char c )
: RCPointer<string>( new string( count, c ))
{}
int Length()
{ return Object()->length(); }
String SubString( int index, int count ) const
{ return Object()->substr( index-1, count ); }
const char* c_str() const
{ return Object()->c_str(); }
char* c_str()
{ return const_cast<char*>(Object()->c_str()); }
char operator[] ( int n ) const
{ return (*Object())[n-1]; }
char& operator[] ( int n )
{ return (*Object())[n-1]; }
String& operator += ( const String& str )
{
*Object() += *str.Object();
return *this;
}
friend inline bool operator == ( const String&, const String& );
friend inline bool operator != ( const String&, const String& );
friend inline bool operator < ( const String&, const String& );
friend inline bool operator <= ( const String&, const String& );
friend inline bool operator > ( const String&, const String& );
friend inline bool operator >= ( const String&, const String& );
friend inline String operator + ( const String&, const String& );
static String StringOfChar( char ch, int count )
{ return String( count, ch ); }
};
inline String operator + ( const String& str1, const String& str2 )
{ return *str1.Object() + *str2.Object(); }
inline bool operator == ( const String& str1, const String& str2 )
{ return *str1.Object() == *str2.Object(); }
inline bool operator != ( const String& str1, const String& str2 )
{ return *str1.Object() != *str2.Object(); }
inline bool operator < ( const String& str1, const String& str2 )
{ return *str1.Object() < *str2.Object(); }
inline bool operator > ( const String& str1, const String& str2 )
{ return *str1.Object() > *str2.Object(); }
inline bool operator <= ( const String& str1, const String& str2 )
{ return *str1.Object() <= *str2.Object(); }
inline bool operator >= ( const String& str1, const String& str2 )
{ return *str1.Object() >= *str2.Object(); }
#ifdef ENABLE_EXCEPTION_HANDLING_DISABLING
#endif
}   
#endif  
#else
#error "String type is not selected!"
#endif
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libExtern/../libEvaluator/EvCell.h
#ifndef EvCellH
#define EvCellH
// # # # included /home/smalkov/dev/Wafl/src/libEvaluator/../libCommon/LazyString.h
#ifndef SML_LazyStringH
#define SML_LazyStringH
// # # # included /home/smalkov/dev/Wafl/src/libCommon/RefCount.h
#ifndef SML_RefCountH
#define SML_RefCountH
#include <atomic>
namespace sml {
class AtomicCounter
{
public:
AtomicCounter()
: Counter_( 0 )
{}
AtomicCounter( unsigned n )
: Counter_( n )
{}
void Init( unsigned n )
{
Counter_.store( n, std::memory_order::memory_order_relaxed );
}
void Increment()
{
Counter_.fetch_add( 1, std::memory_order::memory_order_relaxed );
}
unsigned int Get()
{
return Counter_.load( std::memory_order::memory_order_relaxed );
}
bool DecrementAndCheckIfZero()
{
return Counter_.fetch_sub( 1, std::memory_order::memory_order_relaxed ) == 1;
}
private:
std::atomic<unsigned int> Counter_;
};
class AtomicDebugCounter
{
public:
static std::atomic<unsigned long long> inccount;
static std::atomic<unsigned long long> deccount;
static std::atomic<unsigned long long> delcount;
AtomicDebugCounter()
: Counter_( 0 )
{}
AtomicDebugCounter( unsigned n )
: Counter_( n )
{
inccount += n;
}
void Init( unsigned n )
{
inccount += n;
Counter_.store( n, std::memory_order::memory_order_relaxed );
}
void Increment()
{
inccount++;
Counter_.fetch_add( 1, std::memory_order::memory_order_relaxed );
}
unsigned int Get()
{
return Counter_.load( std::memory_order::memory_order_relaxed );
}
bool DecrementAndCheckIfZero()
{
deccount++;
bool todel = Counter_.fetch_sub( 1, std::memory_order::memory_order_relaxed ) == 1;
if( todel )
delcount++;
return todel;
}
private:
std::atomic<unsigned int> Counter_;
};
class NonAtomicCounter
{
public:
NonAtomicCounter()
: Counter_( 0 )
{}
NonAtomicCounter( unsigned n )
: Counter_( n )
{}
void Init( unsigned n )
{
Counter_ = n;
}
void Increment()
{
Counter_++;
}
unsigned int Get()
{
return Counter_;
}
bool DecrementAndCheckIfZero()
{
return !--Counter_;
}
private:
unsigned int Counter_;
};
#ifdef WAFL_DISABLE_PARALLEL_EVALUATION
using tRefCount = NonAtomicCounter;
#else
#ifdef NDEBUG
using tRefCount = AtomicCounter;
#else
using tRefCount = AtomicDebugCounter;
#endif
#endif
}   
#endif  
#ifndef DISABLE_LAZY_STRINGS_POOL_ALLOCATION
// # # # included /home/smalkov/dev/Wafl/src/libCommon/../libMemory/HeapMemoryPool.h
#ifndef SMM_HeapMemoryPoolH
#define SMM_HeapMemoryPoolH
// # # # included /home/smalkov/dev/Wafl/src/libMemory/MemoryPoolZoneManager.h
#ifndef SMM_MemoryPoolZoneManagersH
#define SMM_MemoryPoolZoneManagersH
// # # # included /home/smalkov/dev/Wafl/src/libMemory/MemoryPoolAtom.h
#ifndef SMM_MemoryPoolAtomH
#define SMM_MemoryPoolAtomH
namespace smm {
template<
class T_Atom = t_Wafl_Word,		
unsigned sz_AtomSize = 0		
>
class MemoryPoolAtom
{
public:
static constexpr unsigned atomSize()
{
return
sz_AtomSize >= sizeof( T_Atom )
? sz_AtomSize >= sizeof( MemoryPoolAtom* )
? sz_AtomSize
: sizeof( MemoryPoolAtom* )
: sizeof( T_Atom ) >= sizeof( MemoryPoolAtom* )
? sizeof( T_Atom )
: sizeof( MemoryPoolAtom* );
}
public:
MemoryPoolAtom() {}
void SetNextAtom( MemoryPoolAtom* a )
{ NextAtomPtr_ = a; }
MemoryPoolAtom* NextAtom() const
{ return NextAtomPtr_; }
private:
MemoryPoolAtom( const MemoryPoolAtom& ) = delete;
MemoryPoolAtom( MemoryPoolAtom&& ) = delete;
MemoryPoolAtom& operator= ( const MemoryPoolAtom& ) = delete;
MemoryPoolAtom& operator= ( MemoryPoolAtom&& ) = delete;
union {
unsigned char		ReservedDataSpace_[ atomSize() ];	
MemoryPoolAtom*		NextAtomPtr_;						
};
};
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libMemory/MemoryPoolPolicy.h
#ifndef SMM_MemoryPoolPolicyH
#define SMM_MemoryPoolPolicyH
#include <string>
namespace smm {
enum class MemoryPoolPolicy {
none = 0x00,
pool_useCounters = 0x01,
pool_mask = 0x0f,
pool_defaultDebug = pool_useCounters,
pool_defaultOptimized = none,
cellMgr_threadSafe = 0x010,
cellMgr_cleanCells = 0x020,
cellMgr_mask = 0x0f0,
cellMgr_defaultDebug = none,
cellMgr_defaultOptimized = none,
zoneMgr_local = 0x0100,
zoneMgr_threadSafe = 0x0400,
zoneMgr_global = 0x0800,
zoneMgr_cleanCells = 0x1000,
zoneMgr_linearResize = 0x0000,
zoneMgr_geomResize = 0x2000,
zoneMgr_mask = 0xff00,
zoneMgr_defaultDebug = zoneMgr_local,
zoneMgr_defaultOptimized = zoneMgr_global,
defaultDebugPolicy = pool_defaultDebug | cellMgr_defaultDebug | zoneMgr_defaultDebug,
defaultOptimizedPolicy = pool_defaultOptimized | cellMgr_defaultOptimized | zoneMgr_defaultOptimized,
#ifdef NDEBUG
defaultPolicy = defaultOptimizedPolicy
#else
defaultPolicy = defaultDebugPolicy
#endif
};
constexpr MemoryPoolPolicy operator | ( MemoryPoolPolicy p1, MemoryPoolPolicy p2 )
{
return static_cast<MemoryPoolPolicy>(
static_cast<unsigned>( p1 )
|
static_cast<unsigned>( p2 )
);
}
constexpr MemoryPoolPolicy operator & ( MemoryPoolPolicy p1, MemoryPoolPolicy p2 )
{
return static_cast<MemoryPoolPolicy>(
static_cast<unsigned>( p1 )
&
static_cast<unsigned>( p2 )
);
}
constexpr MemoryPoolPolicy operator - ( MemoryPoolPolicy p1, MemoryPoolPolicy p2 )
{
return static_cast<MemoryPoolPolicy>(
static_cast<unsigned>( p1 )
&
~static_cast<unsigned>( p2 )
);
}
constexpr MemoryPoolPolicy operator + ( MemoryPoolPolicy p1, MemoryPoolPolicy p2 )
{
return p1 | p2;
}
constexpr bool includes ( MemoryPoolPolicy p1, MemoryPoolPolicy p2 )
{
return (p1 & p2) == p2;
}
std::string policyToString( MemoryPoolPolicy p, const char* sep=0 );
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libMemory/../libCommon/OptionalMutex.h
#ifndef SML_OptionalMutexH
#define SML_OptionalMutexH
#include <mutex>
#include <type_traits>
namespace sml {
class DummyMutex
{
public:
void lock() {}
bool try_lock() { return true; }
void unlock() {}
};
class DummyLock
{
public:
template<class T>
DummyLock( T& ) {}
void lock() {}
bool try_lock() { return true; }
void unlock() {}
template <class T>
bool try_lock_until( const T& abs_time )
{ return true;};
template <class T>
bool try_lock_for( const T& rel_time )
{ return true;};
};
template< bool UseLocking >
class OptionalMutex
{
public:
using tMutex = typename std::conditional< UseLocking, std::mutex, DummyMutex >::type;
using tUniqueLock = typename std::conditional< UseLocking, std::unique_lock<std::mutex>, DummyLock >::type;
};
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libMemory/../libCommon/Memory.h
#ifndef SML_MemoryH
#define SML_MemoryH
#include <memory>
namespace sml {
template<class T, typename... Args>
std::shared_ptr<T> make_shared_protected( Args&&... args )
{
struct mkshare_helper : public T {
mkshare_helper( Args&&... args )
: T( std::forward<Args>( args )... )
{}
};
return std::make_shared<mkshare_helper>( std::forward<Args>( args )... );
};
}   
#endif  
#include <memory>
#include <cstring>
#include <vector>
namespace smm {
class MemoryPoolZoneManager
{
protected:
using BaseAtomType = MemoryPoolAtom< t_Wafl_Word >;
class MemoryZoneBase
{
public:
MemoryZoneBase( size_t atomSize, size_t zoneSize )
: AtomSize_( atomSize ),
ZoneSize_( zoneSize )
{
AllocatedMemory_ = new char[ zoneSizeInBytes() ];
}
~MemoryZoneBase()
{
delete [] AllocatedMemory_;
}
void Clear()
{
memset( AllocatedMemory_, 0, zoneSizeInBytes() );
}
protected:
MemoryZoneBase( const MemoryZoneBase& ) = delete;
MemoryZoneBase( MemoryZoneBase&& ) = delete;
MemoryZoneBase& operator= ( const MemoryZoneBase& ) = delete;
MemoryZoneBase& operator= ( MemoryZoneBase&& ) = delete;
size_t zoneSizeInBytes() const
{
return AtomSize_ * ZoneSize_;
}
size_t		AtomSize_;
size_t		ZoneSize_;
char*		AllocatedMemory_;
};
MemoryPoolZoneManager( size_t atomSize )
: AtomSize_( atomSize )
{}
virtual ~MemoryPoolZoneManager()
{
reset();
}
void reset()
{
for( MemoryZoneBase* zone : MemoryZones_ )
delete zone;
MemoryZones_.clear();
}
void releaseAtoms( BaseAtomType* releasedAtomList )
{
if( releasedAtomList )
ReleasedAtomLists_.push_back( releasedAtomList );
}
void annotateAllocatedSize( size_t allocatedSize )
{
TotalAllocatedSize_ += allocatedSize;
}
static constexpr size_t minimalSizeInAtoms()
{ return 16; }
static constexpr size_t defaultSizeInBytes()
{ return 65536; }
static constexpr size_t defaultSizeInAtoms()
{ return 64; }
static constexpr size_t atomSizeThreshold()
{ return 1024; }
MemoryPoolZoneManager( const MemoryPoolZoneManager& ) = delete;
MemoryPoolZoneManager( MemoryPoolZoneManager&& ) = delete;
MemoryPoolZoneManager& operator= ( const MemoryPoolZoneManager& ) = delete;
MemoryPoolZoneManager& operator= ( MemoryPoolZoneManager&& ) = delete;
size_t							AtomSize_;					
size_t							TotalAllocatedSize_ = 0;	
std::vector<MemoryZoneBase*>	MemoryZones_;				
std::vector<BaseAtomType*>		ReleasedAtomLists_;			
friend class MemoryPoolTest;
friend class MemoryPoolMonitor;
};
template <
size_t sz_AtomSize,				
size_t sz_AtomsInZone = 0,		
bool IsGlobal = false,			
bool ReqThreadSafe = false,		
bool UseCleanAtoms = false		
>
class UntypedMemoryPoolZoneManager : public
MemoryPoolZoneManager,
std::enable_shared_from_this<
UntypedMemoryPoolZoneManager <
sz_AtomSize,
sz_AtomsInZone,
IsGlobal,
ReqThreadSafe,
UseCleanAtoms
>
>
{
public:
constexpr static bool IsThreadSafe = ReqThreadSafe || IsGlobal;
using InternalAtomType = MemoryPoolAtom< t_Wafl_Word, sz_AtomSize >;
using tUniqueLock = typename sml::OptionalMutex<IsThreadSafe>::tUniqueLock;
protected:
class MemoryZone : public MemoryZoneBase
{
public:
MemoryZone( size_t zoneSize )
: MemoryZoneBase( atomSize(), zoneSize )
{}
InternalAtomType* FirstAtom() const
{ return reinterpret_cast<InternalAtomType*>( AllocatedMemory_ ); }
InternalAtomType* LastAtom() const
{ return FirstAtom() + SizeInAtoms() - 1; }
InternalAtomType* EndAtom() const
{ return FirstAtom() + SizeInAtoms(); }
size_t SizeInAtoms() const
{ return ZoneSize_; }
size_t SizeInBytes() const
{ return SizeInAtoms() * sizeof( InternalAtomType ); }
void ConnectAtoms()
{
InternalAtomType* atom = FirstAtom();
InternalAtomType* last = LastAtom();
while( atom != last ) {
#ifndef NDEBUG
( (t_Wafl_Word*) atom )[ 1 ] = 0x4444434342424141;
#endif
atom->SetNextAtom( atom + 1 );
atom++;
}
#ifndef NDEBUG
( (t_Wafl_Word*) last )[ 1 ] = 0x4444434342424141;
#endif
last->SetNextAtom( nullptr );
}
};
public:
static std::shared_ptr<UntypedMemoryPoolZoneManager> New()
{
if( IsGlobal ) {
static std::shared_ptr<UntypedMemoryPoolZoneManager>
singletonInstance = createNew();
return singletonInstance;
}
else
return createNew();
}
~UntypedMemoryPoolZoneManager()
{
Reset();
}
size_t GetMoreAtoms( InternalAtomType*& firstNewAtom, InternalAtomType*& lastNewAtom )
{
size_t n = getReleasedAtoms( firstNewAtom, lastNewAtom, nextZoneSize() );
return n ? n : allocateNewZone( firstNewAtom, lastNewAtom );
}
void ReleaseAtoms( InternalAtomType* releasedAtomList )
{
tUniqueLock lock( ZoneMgrMutex_ );
releaseAtoms( reinterpret_cast<BaseAtomType*>( releasedAtomList ) );
}
void Reset()
{
tUniqueLock lock( ZoneMgrMutex_ );
reset();
}
protected:
UntypedMemoryPoolZoneManager()
: MemoryPoolZoneManager( atomSize() ),
InitialZoneSize_( initialZoneSize() ),
LastZoneSize_( 0 )
{}
static std::shared_ptr<UntypedMemoryPoolZoneManager> createNew()
{
return sml::make_shared_protected<UntypedMemoryPoolZoneManager>();
}
size_t nextZoneSize() const
{
return initialZoneSize();
}
size_t allocateNewZone( InternalAtomType*& firstNewAtom, InternalAtomType*& lastNewAtom )
{
MemoryZone* newZone = new MemoryZone( nextZoneSize() );
size_t allocatedSize = newZone->SizeInAtoms();
if( UseCleanAtoms )
newZone->Clear();
newZone->ConnectAtoms();
{
tUniqueLock lock( ZoneMgrMutex_ );
MemoryZones_.push_back( newZone );
LastZoneSize_ = allocatedSize;
annotateAllocatedSize( allocatedSize );
}
firstNewAtom = newZone->FirstAtom();
lastNewAtom = newZone->LastAtom();
return allocatedSize;
}
size_t getReleasedAtoms( InternalAtomType*& firstNewAtom, InternalAtomType*& lastNewAtom, size_t upTo = 0 )
{
tUniqueLock lock( ZoneMgrMutex_ );
if( ReleasedAtomLists().empty() )
return 0;
firstNewAtom = ReleasedAtomLists().back();
ReleasedAtomLists().pop_back();
lock.unlock();
InternalAtomType* p = firstNewAtom;
size_t n = 1;
if( upTo ) {
while( n < upTo && p->NextAtom() ) {
#ifndef NDEBUG
( (t_Wafl_Word*) p )[ 1 ] = 0x4141424243434444;
#endif
n++;
p = p->NextAtom();
}
if( p->NextAtom() ) {
lock.lock();
ReleasedAtomLists().push_back( p->NextAtom() );
lock.unlock();
p->SetNextAtom( nullptr );
}
}
else
while( p->NextAtom() ) {
#ifndef NDEBUG
( (t_Wafl_Word*) p )[ 1 ] = 0x4141424243434444;
#endif
n++;
p = p->NextAtom();
}
lastNewAtom = p;
return n;
}
static constexpr size_t atomSize()
{ return sizeof( InternalAtomType ); }
static constexpr size_t initialZoneSize()
{
return
sz_AtomsInZone > minimalSizeInAtoms()
? sz_AtomsInZone
: atomSize() <= atomSizeThreshold()
? defaultSizeInBytes() / atomSize()
: defaultSizeInAtoms();
}
private:
std::vector<InternalAtomType*>& ReleasedAtomLists()
{
return reinterpret_cast<std::vector<InternalAtomType*>&>( ReleasedAtomLists_ );
}
size_t							InitialZoneSize_;		
size_t							LastZoneSize_;			
mutable typename sml::OptionalMutex<IsThreadSafe>::tMutex
ZoneMgrMutex_;	
friend class MemoryPoolTest;
};
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libMemory/MemoryPoolCellManager.h
#ifndef SMM_MemoryPoolCellManagersH
#define SMM_MemoryPoolCellManagersH
// # # # included /home/smalkov/dev/Wafl/src/libMemory/MemoryPoolCounters.h
#ifndef SMM_MemoryPoolCountersH
#define SMM_MemoryPoolCountersH
#include <cstddef>
#include <type_traits>
namespace smm {
class MemoryPoolUsageCounters
{
public:
std::size_t ReservedCount() const
{ return Reserved_; }
t_Wafl_Signed_Word UsedCount() const
{ return (t_Wafl_Signed_Word) AllocActionCounter_ - FreeActionCounter_; }
std::size_t FreeAtomsCount() const
{ return ReservedCount() - UsedCount(); }
std::size_t AllocActionCount() const
{ return AllocActionCounter_; }
std::size_t FreeActionCount() const
{ return FreeActionCounter_; }
bool WasUsed() const
{ return AllocActionCounter_ || FreeActionCounter_; }
void AnnotateAlloc()
{ AllocActionCounter_++; }
void AnnotateAlloc( unsigned n )
{ AllocActionCounter_ += n; }
void AnnotateFree()
{ FreeActionCounter_++; }
void AnnotateFree( unsigned n )
{ FreeActionCounter_ += n; }
void AnnotateResizeFor( std::size_t delta )
{ Reserved_ += delta; }
void UpdateBy( const MemoryPoolUsageCounters& counters )
{
Reserved_ = counters.ReservedCount();
AllocActionCounter_ += counters.AllocActionCount();
FreeActionCounter_ += counters.FreeActionCount();
}
void Reset()
{
Reserved_ = AllocActionCounter_ = FreeActionCounter_ = 0;
}
protected:
std::size_t		Reserved_ = 0;				
std::size_t		AllocActionCounter_ = 0;	
std::size_t		FreeActionCounter_ = 0;		
};
class CapacityOnlyMemoryPoolUsageCounters : public MemoryPoolUsageCounters
{
public:
constexpr static t_Wafl_Signed_Word UsedCount()
{ return 0; }
constexpr static std::size_t FreeAtomsCount()
{ return 0; }
constexpr static std::size_t AllocActionCount()
{ return 0; }
constexpr static std::size_t FreeActionCount()
{ return 0; }
constexpr static void AnnotateAlloc() {}
constexpr static void AnnotateAlloc( unsigned n ) {}
constexpr static void AnnotateFree() {}
constexpr static void AnnotateFree( unsigned n ) {}
};
class DummyMemoryPoolUsageCounters : public MemoryPoolUsageCounters
{
public:
constexpr static std::size_t ReservedCount()
{ return 0; }
constexpr static std::size_t UsedCount()
{ return 0; }
constexpr static std::size_t FreeAtomsCount()
{ return 0; }
constexpr static std::size_t AllocActionCount()
{ return 0; }
constexpr static std::size_t FreeActionCount()
{ return 0; }
constexpr static void AnnotateAlloc() {}
constexpr static void AnnotateAlloc( unsigned n ) {}
constexpr static void AnnotateFree() {}
constexpr static void AnnotateFree( unsigned n ) {}
constexpr static void AnnotateResizeFor( std::size_t delta ) {}
constexpr static void UpdateBy( const DummyMemoryPoolUsageCounters& counters ) {}
constexpr static void Reset() {}
};
template <bool UseCounters>
using OptionalMemoryPoolUsageCounters = std::conditional_t<
UseCounters,
MemoryPoolUsageCounters,
CapacityOnlyMemoryPoolUsageCounters
>;
}   
#endif  
#include <memory>
namespace smm {
template <
class T_Atom,						
class T_ZoneManager,				
bool MT_Shared = false,				
bool UseCleanAtoms = false,			
class T_UsageCounters
= DummyMemoryPoolUsageCounters	
>
class MemoryPoolCellManager
{
protected:
using InternalAtomType = typename T_ZoneManager::InternalAtomType;
using ExternalAtomType = T_Atom;
using tMutex = typename sml::OptionalMutex<MT_Shared>::tMutex;
using tUniqueLock = typename sml::OptionalMutex<MT_Shared>::tUniqueLock;
public:
MemoryPoolCellManager( std::shared_ptr<T_ZoneManager> zoneManager )
: FreeAtoms_( nullptr ),
ZoneManager_( zoneManager )
{}
~MemoryPoolCellManager()
{
reset();
}
const T_UsageCounters& UsageCounters() const
{ return UsageCounters_; }
ExternalAtomType* Alloc()
{
tUniqueLock lock( CellMgrMutex_ );
if( !FreeAtoms_ )
allocateMoreCells();
InternalAtomType* tmp = FreeAtoms_;
FreeAtoms_ = FreeAtoms_->NextAtom();
if( UseCleanAtoms )
tmp->SetNextAtom( nullptr );
#ifndef NDEBUG
*(t_Wafl_Word*) tmp = 0x4142434445464748;
#endif
UsageCounters_.AnnotateAlloc();
return reinterpret_cast<ExternalAtomType*>( tmp );
}
void Free( ExternalAtomType* atom )
{
tUniqueLock lock( CellMgrMutex_ );
reinterpret_cast<InternalAtomType*>( atom )->SetNextAtom( FreeAtoms_ );
FreeAtoms_ = reinterpret_cast<InternalAtomType*>( atom );
UsageCounters_.AnnotateFree();
}
protected:
void allocateMoreCells()
{
InternalAtomType *first, *last;
size_t n = ZoneManager_->GetMoreAtoms( first, last );
last->SetNextAtom( FreeAtoms_ );
FreeAtoms_ = first;
UsageCounters_.AnnotateResizeFor( n );
}
void releaseCells()
{
ZoneManager_->ReleaseAtoms( FreeAtoms_ );
FreeAtoms_ = nullptr;
}
void reset()
{
releaseCells();
FreeAtoms_ = nullptr;
}
protected:
MemoryPoolCellManager( const MemoryPoolCellManager& ) = delete;
MemoryPoolCellManager( MemoryPoolCellManager&& ) = delete;
MemoryPoolCellManager& operator= ( const MemoryPoolCellManager& ) = delete;
MemoryPoolCellManager& operator= ( MemoryPoolCellManager&& ) = delete;
std::shared_ptr<T_ZoneManager>	ZoneManager_;		
InternalAtomType*				FreeAtoms_;			
T_UsageCounters					UsageCounters_;		
tMutex							CellMgrMutex_;		
friend class MemoryPoolTest;
};
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libMemory/MemoryPoolDescription.h
#ifndef SMM_MemoryPoolDescriptionH
#define SMM_MemoryPoolDescriptionH
#include <string>
#include <thread>
namespace smm {
class MemoryPoolDescription
{
public:
MemoryPoolDescription(
size_t atomByteSize,
const std::string poolName,
MemoryPoolPolicy policy,
const MemoryPoolUsageCounters* usageCounters = nullptr,
const MemoryPoolZoneManager* zoneManager = nullptr
)
:	AtomByteSize_( atomByteSize ),
PoolName_( poolName ),
PoolPolicy_( policy ),
UsageCounters_( usageCounters ),
ZoneManager_( zoneManager ),
ThreadId_( std::this_thread::get_id() )
{}
public:
size_t AtomByteSize() const
{ return AtomByteSize_; }
size_t ElementSize() const
{ return AtomByteSize(); }
size_t AtomWordSize() const
{ return AtomByteSize() / sizeof(void*); }
size_t AtomSize() const
{ return AtomWordSize(); }
const std::string& Name() const
{ return PoolName_; }
std::thread::id ThreadId() const
{ return ThreadId_;	}
std::string Description() const;
std::string HtmlDescription() const;
static std::string HtmlDescriptionHeader();
std::string ShortDescription() const;
static std::string ShortDescriptionHeader();
size_t UsageCount_Reserved() const
{ return UsageCounters_ ? UsageCounters_->ReservedCount() : 0; }
t_Wafl_Signed_Word UsageCount_Used() const
{ return UsageCounters_ ? UsageCounters_->UsedCount() : 0; }
size_t UsageCount_FreeAtoms() const
{ return UsageCounters_ ? UsageCounters_->FreeAtomsCount() : 0; }
size_t UsageCount_AllocAction() const
{ return UsageCounters_ ? UsageCounters_->AllocActionCount() : 0; }
size_t UsageCount_FreeAction() const
{ return UsageCounters_ ? UsageCounters_->FreeActionCount() : 0; }
size_t UsageCount_WasUsed() const
{ return UsageCounters_ && UsageCounters_->WasUsed(); }
private:
size_t							AtomByteSize_;	
std::string						PoolName_;		
const MemoryPoolUsageCounters*	UsageCounters_;	
std::thread::id					ThreadId_;		
const MemoryPoolZoneManager*	ZoneManager_;	
MemoryPoolPolicy				PoolPolicy_;	
friend class MemoryPoolMonitor;
};
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libMemory/MemoryPool.h
#ifndef SMM_MemoryPoolH
#define SMM_MemoryPoolH
namespace smm {
class MemoryPool
{
public:
MemoryPool( const std::string& poolname );
virtual ~MemoryPool();
const std::string& Name() const
{ return PoolName_; }
virtual const MemoryPoolDescription& Description() const = 0;
void PrepareForDestruction();
const std::string& FinalReport() const
{ return FinalShortReport_; }
private:
std::string		PoolName_;							
bool			PreparedForDestruction_ = false;	
std::string		FinalShortReport_;					
};
template<bool UseCounters>
class MemoryPoolWithUsageCounter : public MemoryPool
{
public:
using tUsageCounters = OptionalMemoryPoolUsageCounters<UseCounters>;
MemoryPoolWithUsageCounter( size_t atomByteSize, const std::string& poolname )
: MemoryPool( poolname ),
UsageCounters_(),
PoolDescription_(
atomByteSize,
poolname,
UseCounters
? MemoryPoolPolicy::defaultPolicy + MemoryPoolPolicy::pool_useCounters
: MemoryPoolPolicy::defaultPolicy - MemoryPoolPolicy::pool_useCounters,
&UsageCounters_
)
{}
~MemoryPoolWithUsageCounter()
{
PrepareForDestruction();
}
const MemoryPoolDescription& Description() const override
{ return PoolDescription_; }
const tUsageCounters& UsageCounters() const
{ return UsageCounters_; }
void AnnotateAlloc()
{ UsageCounters_.AnnotateAlloc(); }
void AnnotateAlloc( unsigned n )
{ UsageCounters_.AnnotateAlloc( n ); }
void AnnotateFree()
{ UsageCounters_.AnnotateFree(); }
void AnnotateFree( unsigned n )
{ UsageCounters_.AnnotateFree( n ); }
protected:
MemoryPoolWithUsageCounter( const MemoryPoolWithUsageCounter& ) = delete;
MemoryPoolWithUsageCounter( MemoryPoolWithUsageCounter&& ) = delete;
MemoryPoolWithUsageCounter& operator= ( const MemoryPoolWithUsageCounter& ) = delete;
MemoryPoolWithUsageCounter& operator= ( MemoryPoolWithUsageCounter&& ) = delete;
tUsageCounters			UsageCounters_;		
MemoryPoolDescription	PoolDescription_;	
};
}   
#endif  
namespace smm {
template <
class T_Atom,							
size_t sz_AtomSize = 0,					
size_t sz_AtomsInZone = 0,				
MemoryPoolPolicy Policy
= MemoryPoolPolicy::defaultPolicy	
>
class HeapMemoryPool : public MemoryPool
{
public:
using tUsageCounters = OptionalMemoryPoolUsageCounters<
includes( Policy, MemoryPoolPolicy::pool_useCounters )
>;
using InternalAtomType = MemoryPoolAtom<T_Atom, sz_AtomSize>;
using ExternalAtomType = T_Atom;
using tZoneManager = UntypedMemoryPoolZoneManager<
sizeof( InternalAtomType ),
sz_AtomsInZone,
includes( Policy, MemoryPoolPolicy::zoneMgr_global ), 		
includes( Policy, MemoryPoolPolicy::zoneMgr_threadSafe ), 	
includes( Policy, MemoryPoolPolicy::zoneMgr_cleanCells ) 	
>;
using tCellManager = MemoryPoolCellManager<
T_Atom,
tZoneManager,
includes( Policy, MemoryPoolPolicy::cellMgr_threadSafe ), 	
includes( Policy, MemoryPoolPolicy::cellMgr_cleanCells ), 	
tUsageCounters 					
>;
static_assert(
sizeof( InternalAtomType ) >= sizeof( ExternalAtomType ),
"Atom size not correctly specified!"
);
HeapMemoryPool( const std::string& poolname )
: MemoryPool( poolname ),
ZoneManager_( tZoneManager::New() ),
CellManager_( ZoneManager_ ),
PoolDescription_(
InternalAtomType::atomSize(),
poolname,
Policy,
&CellManager_.UsageCounters(),
&*ZoneManager_
)
{}
~HeapMemoryPool()
{
PrepareForDestruction();
}
ExternalAtomType* Alloc()
{ return CellManager_.Alloc(); }
template<class T>
void Free( T* atom )
{ return CellManager_.Free( reinterpret_cast<ExternalAtomType*>( atom ) ); }
template<class T>
void Free( const T* atom )
{
CellManager_.Free(
reinterpret_cast<ExternalAtomType*>(
const_cast<T*>( atom )
)
);
}
const MemoryPoolDescription& Description() const override
{ return PoolDescription_; }
const tUsageCounters& UsageCounters() const
{ return CellManager_.UsageCounters(); }
private:
std::shared_ptr<tZoneManager>	ZoneManager_;		
tCellManager					CellManager_;		
MemoryPoolDescription			PoolDescription_;	
friend class MemoryPoolTest;
};
}   
#endif  
#endif
class LazyStringTester;
namespace sml {
#ifdef ENABLE_EXCEPTION_HANDLING_DISABLING
#endif
class LazyString
{
public:
using size_type = String::size_type;
using tBaseString = String::tBaseString;
static constexpr size_type npos = std::string::npos;
class LazyStringData
{
public:
LazyStringData()
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(); }
LazyStringData( const String& s )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(s); }
LazyStringData( const LazyStringData* s1, const LazyStringData* s2 )
: Value1_(s1), Value2_(s2), RefCount_(1)
{
s1->AddReference();
s2->AddReference();
}
LazyStringData( char c )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(c); }
LazyStringData( const char* s )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(s); }
LazyStringData( const char* s, int len )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(s,len); }
LazyStringData( short n )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(n); }
LazyStringData( unsigned short n )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(n); }
LazyStringData( int n )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(n); }
LazyStringData( unsigned int n )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(n); }
LazyStringData( long n )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(n); }
LazyStringData( unsigned long n )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(n); }
LazyStringData( long long n )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(n); }
LazyStringData( unsigned long long n )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(n); }
LazyStringData( double d )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(d); }
LazyStringData( double d, char decimalPoint )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(d,decimalPoint); }
LazyStringData( double d, int dec )
: Value2_(0), RefCount_(1)
{ ::new ( &Value1_ ) String( d, dec ); }
LazyStringData( double d, char decimalPoint,bool )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(d,decimalPoint,true); }
LazyStringData( bool b )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String(b); }
LazyStringData( size_type count, char c )
: Value2_(0), RefCount_(1)
{ ::new (&Value1_ ) String( count, c ); }
unsigned int GetReferenceCount() const
{ return RefCount_.Get(); }
void AddReference() const
{ RefCount_.Increment(); }
void Free() const
{
if( RefCount_.DecrementAndCheckIfZero() )
delete this;
}
bool NotEvaluated() const
{ return Value2_; }
bool IsEvaluated() const
{ return !Value2_; }
const String& GetEvaluated() const
{
if( NotEvaluated() )
doEvaluateString();
return EvaluatedString();
}
protected:
~LazyStringData()
{
if( IsEvaluated() )
#ifdef DISABLE_LAZY_STRINGS_POOL_ALLOCATION
if( !Value1_ )
;
else
#endif
EvaluatedString().~String();
else
destructNotEvaluated();
}
const String& EvaluatedString() const
{ return *(String*)&Value1_; }
void SetEvaluatedValue( String& s ) const
{
if( Value1_ )
Value1_->Free();
::new ((long*)&Value1_ ) String(s);
if( Value2_ ){
Value2_->Free();
Value2_ = 0;
}
}
private:
void doEvaluateString() const;
void destructNotEvaluated();
LazyStringData( const LazyStringData& ) = delete;
LazyStringData& operator= ( const LazyStringData& ) = delete;
mutable const LazyStringData*	Value1_;	
mutable const LazyStringData*	Value2_;	
mutable sml::tRefCount			RefCount_;	
#ifndef DISABLE_LAZY_STRINGS_POOL_ALLOCATION
public:
void* operator new( size_t )
{ return MemoryPool_.Alloc(); }
void Deallocate() const
{ MemoryPool_.Free(this); }
thread_local
static smm::HeapMemoryPool<LazyStringData> MemoryPool_;
private:
void operator delete( void* s )
{ reinterpret_cast<LazyStringData*>(s)->Deallocate(); }
#if WAFL_COMPILER == WAFL_VER_GCC || WAFL_COMPILER == WAFL_VER_MSVC || WAFL_COMPILER == WAFL_VER_CLANG
friend class LazyString;
#endif
#else
void Deallocate() const
{
We need no destruction, just deallocation.
Value1_ = Value2_ = 0;
::delete (this);
}
#endif
friend class ::LazyStringTester;
};
public:
LazyString()
: Data( new LazyStringData() )
{}
LazyString( const String& s )
: Data( new LazyStringData(s) )
{}
LazyString( const LazyString& s1, const LazyString& s2 )
: Data( new LazyStringData(s1.Data, s2.Data) )
{}
LazyString( char c )
: Data( new LazyStringData(c) )
{}
LazyString( size_type n, char c )
: Data( new LazyStringData(n,c) )
{}
LazyString( const char* s )
: Data( new LazyStringData(s) )
{}
LazyString( const char* s, int len )
: Data( new LazyStringData( s, len ) )
{}
LazyString( short n )
: Data( new LazyStringData(n) )
{}
LazyString( unsigned short n )
: Data( new LazyStringData(n) )
{}
LazyString( int n )
: Data( new LazyStringData(n) )
{}
LazyString( unsigned int n )
: Data( new LazyStringData(n) )
{}
LazyString( long n )
: Data( new LazyStringData(n) )
{}
LazyString( unsigned long n )
: Data( new LazyStringData(n) )
{}
LazyString( long long n )
: Data( new LazyStringData(n) )
{}
LazyString( unsigned long long n )
: Data( new LazyStringData(n) )
{}
LazyString( double d )
: Data( new LazyStringData(d) )
{}
LazyString( double d, char decimalPoint )
: Data( new LazyStringData(d,decimalPoint) )
{}
LazyString( double d, char decimalPoint, bool )
: Data( new LazyStringData(d,decimalPoint,true) )
{}
LazyString( double d, int dec )
: Data( new LazyStringData( d, dec ) )
{}
explicit LazyString( bool b )
: Data( new LazyStringData(b ? "true" : "false") )
{}
LazyStringData& GetData() const
{ return *Data; }
const String& EvaluatedData() const
{ return GetData().GetEvaluated(); }
bool IsEvaluated() const
{ return GetData().IsEvaluated(); }
bool NotEvaluated() const
{ return GetData().NotEvaluated(); }
bool empty() const
{ return EvaluatedData().empty(); }
size_type length() const
{ return EvaluatedData().length(); }
size_type size() const
{ return length(); }
LazyString subStr( size_type index, size_type count ) const
{ return LazyString( EvaluatedData().subStr( index, count )); }
LazyString substr( size_type index, size_type count ) const
{ return subStr( index, count ); }
LazyString strLeft( size_type count ) const
{ return LazyString( EvaluatedData().strLeft( count )); }
LazyString strRight( size_type count ) const
{ return LazyString( EvaluatedData().strRight( count )); }
LazyString strRightFrom( size_type count ) const
{ return LazyString( EvaluatedData().strRightFrom( count )); }
LazyString strLTrim() const
{ return LazyString( EvaluatedData().strLTrim()); }
LazyString strRTrim() const
{ return LazyString( EvaluatedData().strRTrim()); }
LazyString strTrim() const
{ return LazyString( EvaluatedData().strTrim()); }
size_type pos( const LazyString& s ) const
{ return EvaluatedData().pos( s.EvaluatedData() ); }
size_type nextPos( const LazyString& s, size_type from ) const
{ return EvaluatedData().nextPos( s.EvaluatedData(), from ); }
size_type lastPos( const LazyString& s ) const
{ return EvaluatedData().lastPos( s.EvaluatedData() ); }
size_type nextLastPos( const LazyString& s, size_type from ) const
{ return EvaluatedData().nextLastPos( s.EvaluatedData(), from ); }
size_type posI( const LazyString& s ) const
{ return EvaluatedData().posI( s.EvaluatedData() ); }
size_type nextPosI( const LazyString& s, size_type from ) const
{ return EvaluatedData().nextPosI( s.EvaluatedData(), from ); }
size_type lastPosI( const LazyString& s ) const
{ return EvaluatedData().lastPosI( s.EvaluatedData() ); }
size_type nextLastPosI( const LazyString& s, size_type from ) const
{ return EvaluatedData().nextLastPosI( s.EvaluatedData(), from ); }
size_type findFirstOf( const LazyString& s, size_type pos=-1 ) const
{ return EvaluatedData().findFirstOf( s.EvaluatedData(), pos ); }
LazyString replace( const LazyString& s, const LazyString& d, size_type pos ) const
{ return LazyString( EvaluatedData().replace( s.EvaluatedData(), d.EvaluatedData(), pos )); }
LazyString replaceAll( const LazyString& s, const LazyString& d ) const
{ return LazyString( EvaluatedData().replaceAll( s.EvaluatedData(), d.EvaluatedData() )); }
LazyString replaceI( const LazyString& s, const LazyString& d, size_type pos ) const
{ return LazyString( EvaluatedData().replaceI( s.EvaluatedData(), d.EvaluatedData(), pos )); }
LazyString replaceAllI( const LazyString& s, const LazyString& d ) const
{ return LazyString( EvaluatedData().replaceAllI( s.EvaluatedData(), d.EvaluatedData() )); }
LazyString insert( const LazyString& s, size_type pos=0 ) const
{ return LazyString( EvaluatedData().insert( s.EvaluatedData(), pos )); }
LazyString insert( const char* s, size_type pos=0 ) const
{ return LazyString( EvaluatedData().insert( s, pos )); }
const char* c_str() const
{ return EvaluatedData().c_str(); }
LazyString lowerCase() const
{ return LazyString( EvaluatedData().lowerCase()); }
LazyString upperCase() const
{ return LazyString( EvaluatedData().upperCase()); }
LazyString reverse() const
{ return LazyString( EvaluatedData().reverse()); }
const std::string& asStdString() const
{ return EvaluatedData().asStdString(); }
const tBaseString& asBaseString() const
{ return EvaluatedData().asBaseString(); }
const String& asString() const
{ return EvaluatedData(); }
const std::string& str() const
{ return EvaluatedData().str(); }
long asInt32() const
{ return EvaluatedData().asInt32(); }
long asInt32( long def ) const
{ return EvaluatedData().asInt32(def); }
t_Wafl_Signed_Word asInt() const
{ return EvaluatedData().asInt(); }
t_Wafl_Signed_Word asInt( t_Wafl_Signed_Word def ) const
{ return EvaluatedData().asInt(def); }
double asFloat() const
{ return EvaluatedData().asFloat(); }
double asFloat( double def ) const
{ return EvaluatedData().asFloat(def); }
bool asBool() const
{ return EvaluatedData().asBool(); }
String EncodeUrlQuery() const
{ return EvaluatedData().EncodeUrlQuery(); }
String DecodeUrlQuery() const
{ return EvaluatedData().DecodeUrlQuery(); }
String EncodeHtmlText() const
{ return EvaluatedData().EncodeHtmlText(); }
String EncodeSqlString() const
{ return EvaluatedData().EncodeSqlString(); }
String EncodeCString() const
{ return EvaluatedData().EncodeCString(); }
String EncodeWaflString() const
{ return EvaluatedData().EncodeWaflString(); }
String EncodeWaflStringWithQuotes( char quote = '\'' ) const
{ return EvaluatedData().EncodeWaflStringWithQuotes( quote ); }
char operator[] ( int n ) const
{ return EvaluatedData()[n]; }
LazyString operator + ( const LazyString& s ) const
{
return LazyString( *this, s );
}
LazyString& operator += ( const LazyString& str )
{
LazyStringData* data = new LazyStringData( Data, str.Data );
Data->Free();
Data = data;
return *this;
}
void concatSubStr( const LazyString& s, size_type pos, size_type len )
{
LazyStringData* data = new LazyStringData( Data, new LazyStringData( s.subStr(pos,len).asString()) );
Data->Free();
Data = data;
}
void concat( const char* s )
{
LazyStringData* data = new LazyStringData( Data, new LazyStringData(s) );
Data->Free();
Data = data;
}
bool operator == ( const char* txt ) const
{ return EvaluatedData() == txt; }
bool operator == ( const LazyString& s ) const
{ return EvaluatedData() == s.EvaluatedData(); }
bool operator != ( const LazyString& s ) const
{ return EvaluatedData() != s.EvaluatedData(); }
bool operator < ( const LazyString& s ) const
{ return EvaluatedData() < s.EvaluatedData(); }
bool operator <= ( const LazyString& s ) const
{ return EvaluatedData() <= s.EvaluatedData(); }
bool operator > ( const LazyString& s ) const
{ return EvaluatedData() > s.EvaluatedData(); }
bool operator >= ( const LazyString& s ) const
{ return EvaluatedData() >= s.EvaluatedData(); }
short Compare( const LazyString& s ) const
{ return short(EvaluatedData().Compare(s.EvaluatedData() )); }
static const LazyString& NullString()
{
static const LazyString nullString( String::NullString() );
return nullString;
}
bool IsNull() const
{ return EvaluatedData().IsNull(); }
LazyString( const LazyString& s )
: Data( s.Data )
{ Data->AddReference(); }
~LazyString()
{ Data->Free(); }
LazyString& operator = ( const LazyString& s )
{
if( Data != s.Data ){
s.Data->AddReference();
Data->Free();
Data = s.Data;
}
return *this;
}
void __Instantiate() const
{ Data->AddReference(); }
void __Deinstantiate() const
{ Data->Free(); }
private:
LazyStringData* Data;
public:
friend class ::LazyStringTester;
};
#ifdef ENABLE_EXCEPTION_HANDLING_DISABLING
#endif
}   
std::istream& operator>>( std::istream& istr, sml::LazyString& s );
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libEvaluator/../libDataTypes/DataType.h
#ifndef DT_DataTypeH
#define DT_DataTypeH
// # # # included /home/smalkov/dev/Wafl/src/libDataTypes/DataTypeImp.h
#ifndef DT_DataTypeImpH
#define DT_DataTypeImpH
// # # # included /home/smalkov/dev/Wafl/src/libDataTypes/TypeCodes.h
#ifndef DT_TypeCodesH
#define DT_TypeCodesH
#include <map>
namespace WAFL_DataTypes {
enum smTypeCode : long
{
dtUndefined = 0,			
dtFirstPrime = 1,			
dtBool = 1,				
dtInt = 2,				
dtFloat = 4,			
dtString = 8,			
dtLastPrime = dtString,	
dtPrimeMaskAll = 15,	
dtFirstCombinedPrime = 0x10000,							
dtNumeric = dtFirstCombinedPrime | dtInt | dtFloat,		
dtValue = dtNumeric | dtString,							
dtAnyPrime = dtValue | dtBool,							
dtPrimeNotBool = dtValue,											
dtPrimeNotInt = dtFirstCombinedPrime | dtBool | dtFloat | dtString,	
dtPrimeNotFloat = dtFirstCombinedPrime | dtInt | dtBool | dtString,	
dtPrimeNotString = dtFirstCombinedPrime | dtInt | dtFloat | dtBool,	
dtLastCombinedPrime = 0x1ffff,										
dtFirstSpecial = 0x20000,			
dtLibrary = dtFirstSpecial,		
dtDateTime,						
dtDuration,						
dtMimeResource,					
dtMeta,							
dtXmlTag,						
dtDrawing,						
dtBitmap,						
dtLastSpecial = dtBitmap,			
dtLastAllowedSpecial = 0x2ffff,		
dtFirstDynamic = 0x40000,			
dtLastAllowedDynamic = 0x4ffff,		
dtFirstCollection = 0x80000,						
dtMap =			0x80001,						
dtList =		0x80002,						
dtArray =		0x80004,						
dtStringAsCollection = 0x80008,					
dtAbstractCollectionInstance = 0x90000,				
dtFirstAbstractCollection = 0x88000,				
dtIndexableCollection,							
dtSequenceStrCollection,						
dtSequenceCollection,							
dtLastAbstractCollection = dtSequenceCollection,	
dtLastCollection = dtSequenceCollection,			
dtGeneralSequenceInstance = dtList | dtArray,										
dtGeneralSequenceStrInstance = dtGeneralSequenceInstance | dtStringAsCollection,	
dtGeneralIndexableInstance = dtGeneralSequenceStrInstance | dtMap,					
dtGeneralAbstractCollectionInstance = dtGeneralIndexableInstance,		
dtAbstractCollectionMask = 0xfff,										
dtFirstComplex = 0x100000,							
dtFunctional,									
dtTuple = dtFirstComplex | 16,					
dtExactTuple = dtTuple,							
dtExtendableTuple,								
dtRecord = dtFirstComplex | 32,					
dtExactRecord = dtRecord,						
dtExtendableRecord,								
dtRecursive = dtFirstComplex | 64,				
dtInternalReference,							
dtLastComplex = dtInternalReference,				
dtFirstTypeOperator = 0x200000,						
dtGeneralTypeOperator = dtFirstTypeOperator,	
#ifdef WAFL_DATA_TYPES_USING_SET_TYPES
dtSetTypeOperator,								
dtFunSetArgOperator,							
dtUnionTypeOperator,							
dtLastTypeOperator = dtUnionTypeOperator,			
#else
dtLastTypeOperator = dtGeneralTypeOperator,			
#endif
dtFirstExternal = 0x400000,					
dtLastAllowedExternal = 0x40ffff			
};
using smTypeCode_int = long;
class SMTypeCode
{
public:
SMTypeCode( smTypeCode typeClass )
: TypeCode_( typeClass )
{}
smTypeCode Value() const
{ return TypeCode_; }
bool IsUndefined() const
{ return !TypeCode_; }
bool IsPurePolymorphic() const
{ return TypeCode_ < 0; }
unsigned GetPolymorphicIndex() const
{ return TypeCode_ < 0 ? -TypeCode_ : 0; }
bool IsRecursiveReference() const
{ return TypeCode_ == dtRecursive; }
bool IsPrime() const
{ return TypeCode_ >= dtFirstPrime && TypeCode_ <= dtLastPrime; }
bool IsSpecialPrime() const
{ return TypeCode_ >= dtFirstSpecial && TypeCode_ <= dtLastSpecial; }
bool IsInteger() const
{ return TypeCode_ == dtInt; }
bool IsFloat() const
{ return TypeCode_ == dtFloat; }
bool IsBool() const
{ return TypeCode_ == dtBool; }
bool IsString() const
{ return TypeCode_ == dtString; }
bool IsDateTime() const
{ return TypeCode_ == dtDateTime; }
bool IsDuration() const
{ return TypeCode_ == dtDuration; }
bool IsCombined() const
{ return TypeCode_ & dtFirstCombinedPrime; }
bool IsExternal() const
{ return TypeCode_ & dtFirstExternal; }
bool IsCollection() const
{ return TypeCode_ & dtFirstCollection; }
bool IsAbstractCollection() const
{ return TypeCode_ >= dtFirstAbstractCollection && TypeCode_ <= dtLastAbstractCollection; }
bool IsNonAbstractCollection() const
{ return TypeCode_ >= dtFirstCollection && TypeCode_ <= dtLastCollection; }
bool IsNonAbstractCollectionOrString() const
{ return IsNonAbstractCollection() || IsString(); }
bool IsList() const
{ return TypeCode_ == dtList; }
bool IsMap() const
{ return (TypeCode_ & dtMap) == dtMap; }
bool IsArray() const
{ return TypeCode_ == dtArray; }
bool IsExtendable() const
{ return IsExtendableTuple() || IsExtendableRecord(); }
bool IsTuple() const
{ return (TypeCode_ & dtTuple ) == dtTuple; }
bool IsExactTuple() const
{ return TypeCode_ == dtExactTuple; }
bool IsExtendableTuple() const
{ return TypeCode_ == dtExtendableTuple; }
bool IsRecord() const
{ return ( TypeCode_ & dtRecord ) == dtRecord; }
bool IsExactRecord() const
{ return TypeCode_ == dtExactRecord; }
bool IsExtendableRecord() const
{ return TypeCode_ == dtExtendableRecord; }
bool IsFunction() const
{ return TypeCode_ == dtFunctional; }
bool IsTypeOperator() const
{ return TypeCode_ & dtFirstTypeOperator; }
bool IsGeneralTypeOperator() const
{ return TypeCode_ == dtGeneralTypeOperator; }
#ifdef WAFL_DATA_TYPES_USING_SET_TYPES
bool IsSetTypeOperator() const
{ return _TypeCode == dtSetTypeOperator; }
bool IsFunSetArgOperator() const
{ return _TypeCode == dtFunSetArgOperator; }
bool IsUnionTypeOperator() const
{ return _TypeCode == dtUnionTypeOperator; }
#endif
const char* GetBaseName() const
{ return GetTypeName( TypeCode_ ); }
static const char* GetTypeName( smTypeCode tcode )
{
auto& cat = GetNameCatalog();
auto found = cat.find( tcode );
return found != cat.end()
? found->second
: "";
}
bool operator == ( const SMTypeCode& tc ) const
{ return TypeCode_ == tc.TypeCode_; }
private:
static const std::map<smTypeCode, const char*>& GetNameCatalog();
smTypeCode TypeCode_;		
};
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libDataTypes/DataTypeVisitor.h
#ifndef DT_DataTypeVisitorH
#define DT_DataTypeVisitorH
namespace WAFL_DataTypes {
class SMDataType;
class SMDataTypeVisitor
{
public:
enum tState {
sTerminate = -1,
sDontProcessSubnodes = 0,
sContinue = 1
};
virtual tState ProcessTheType( SMDataType& dt ) = 0;
static tState ProcessSubnodes( bool b ) {
return b ? sContinue : sDontProcessSubnodes;
}
};
template<typename FN>
class SMDataTypeVisitorFunction : public SMDataTypeVisitor
{
public:
SMDataTypeVisitorFunction( FN fn )
:Fn_(fn)
{}
tState ProcessTheType( SMDataType& dt )  override
{ return Fn_( dt ); }
FN Fn_;
};
template<typename FN>
SMDataTypeVisitorFunction<FN> makeDataTypeVisitor( FN fn )
{ return SMDataTypeVisitorFunction<FN>(fn); }
}   
#endif  
#include <vector>
#include <set>
#include <functional>
namespace WAFL_DataTypes {
using sml::String;
class SMDataType;
class SMDataTypeImp
#ifdef DEBUG_DATATYPE_COUNT_ON
: public sml::DebugObjectCounter<SMDataTypeImp>
#endif
{
public:
const SMTypeCode& TypeCode() const
{ return TypeCode_; }
virtual String TypeName() const = 0;
bool IsPurePolymorphic() const
{ return TypeCode().IsPurePolymorphic(); }
bool IsRecursiveReference() const
{ return TypeCode().IsRecursiveReference(); }
bool IsUndefined() const
{ return TypeCode().IsUndefined(); }
virtual bool IsFullyDefined() const = 0;
virtual bool IsPolymorphic() const = 0;
unsigned GetPolymorphicIndex() const
{ return TypeCode_.GetPolymorphicIndex(); }
virtual bool IsEssentiallyNonPolymorphic() const = 0;
virtual bool IsExternal ( ) const
{ return false;  }
#ifdef WAFL_DATA_TYPES_USING_SET_TYPES
virtual bool IsSetType() const
{ return false;  }
virtual bool IsSetArgOp() const
{ return false;  }
virtual unsigned GetSetVarArgIndex() const
{ return -1; }
virtual unsigned GetSetVarIndex() const
{ return 0; }
virtual bool IsUnion() const
{ return false;  }
#endif
virtual int Compare( const SMDataTypeImp& dt ) const;
bool operator < ( const SMDataTypeImp& dt ) const
{ return Compare( dt ) < 0; }
bool operator <= ( const SMDataTypeImp& dt ) const
{ return Compare( dt ) <= 0; }
bool operator > ( const SMDataTypeImp& dt ) const
{ return Compare( dt ) > 0; }
bool operator >= ( const SMDataTypeImp& dt ) const
{ return Compare( dt ) >= 0; }
bool operator == ( const SMDataTypeImp& dt ) const
{ return Compare( dt ) == 0; }
bool operator != ( const SMDataTypeImp& dt ) const
{ return Compare( dt ) != 0; }
SMDataTypeImp* Clone() const
{
if( IsPolymorphic() )
return DeepClone();
else
return ShallowClone();
}
virtual bool HasSubTypes() const = 0;
void GetSubTypes( std::vector<SMDataType*>& fill );
void GetSubTypes( std::vector<const SMDataType*>& fill ) const;
virtual SMDataType& CollectionElementType()
{ return getUndefined(); }
virtual SMDataType& CollectionIndexType()
{ return getUndefined(); }
virtual SMDataType& AbstractInstanceType()
{ return getUndefined(); }
virtual SMDataType& RecursivelyReferencedType()
{ return getUndefined(); }
virtual int FunctionArity() const
{ return -1; }
virtual SMDataType& FunctionArgumentType( unsigned n )
{ return getUndefined(); }
virtual int TupleArity() const
{ return -1; }
virtual const SMDataType& TupleElementType( unsigned n ) const
{ return getUndefined(); }
virtual SMDataType& TupleSuffixType( unsigned n )
{ return getUndefined(); }
virtual SMDataType& TupleExtensionType()
{ return getUndefined(); }
virtual SMDataType* RecordElementType( const String& attr )
{ return nullptr; }
virtual SMDataType* RecordExtensionType()
{ return nullptr; }
virtual void AddRecordAttributesTypeNames( std::map<String, String>& attrs, String& extname ) const
{ extname = TypeName(); }
virtual void GetRecordAttributeNames( std::set<String>& attrs ) const
{}
virtual const std::vector<SMDataType>* GetSetElements() const
{ return nullptr; }
virtual SMDataType& TypeOperatorOperandType( unsigned n )
{ return getUndefined(); }
virtual bool TraverseVisitor( SMDataTypeVisitor& aVisitor, unsigned depth )
{ return true; }
bool ShallowTraverseVisitor( SMDataTypeVisitor& aVisitor )
{ return TraverseVisitor( aVisitor, 0 ); }
bool DeepTraverseVisitor( SMDataTypeVisitor& aVisitor )
{ return TraverseVisitor( aVisitor, -1 ); }
virtual bool ForAllSubtypes( std::function<bool( const SMDataType& )> cond ) const
{ return true; }
protected:
SMDataTypeImp( const SMDataTypeImp& ) = delete;
SMDataTypeImp( SMDataTypeImp&& ) = delete;
SMDataTypeImp& operator=( const SMDataTypeImp& ) = delete;
SMDataTypeImp& operator=( SMDataTypeImp&& ) = delete;
virtual SMDataTypeImp* DeepClone() const = 0;
SMDataTypeImp( smTypeCode typeClass )
: RefCount_(1),
TypeCode_(typeClass)
{}
virtual ~SMDataTypeImp()
{}
SMDataTypeImp* ShallowClone() const
{
AddRef();
return const_cast<SMDataTypeImp*>(this);
}
SMDataType& getUndefined() const;
void AddRef() const
{
RefCount_.Increment();
}
void Free() const
{
if( RefCount_.DecrementAndCheckIfZero() )
delete this;
}
mutable sml::tRefCount	RefCount_;		
SMTypeCode				TypeCode_;		
friend class SMDataType;				
friend class DataTypeParser;			
friend class SMDataTypeImp_Tester;		
};
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libDataTypes/dtSimpleTypes.h
#ifndef DT_SimpleTypesH
#define DT_SimpleTypesH
namespace WAFL_DataTypes {
class SMDataTypeSimple : public SMDataTypeImp
{
public:
bool IsFullyDefined() const override
{ return true; }
bool IsPolymorphic() const override
{ return false; }
bool IsEssentiallyNonPolymorphic() const override
{ return true; }
bool HasSubTypes() const override
{ return false; }
protected:
SMDataTypeSimple( smTypeCode id )
: SMDataTypeImp( id )
{}
SMDataTypeImp* DeepClone() const override
{ return ShallowClone(); }
};
class SMDataTypeUndefined : public SMDataTypeSimple
{
public:
static SMDataTypeUndefined* New() {
static SMDataTypeUndefined type_;
return static_cast<SMDataTypeUndefined*>( type_.ShallowClone() );
}
String TypeName() const override
{ return "Undefined"; }
bool IsFullyDefined() const override
{ return false; }
protected:
SMDataTypeUndefined()
: SMDataTypeSimple( dtUndefined )
{}
};
class SMDataTypePurePolymorphic : public SMDataTypeSimple
{
public:
static SMDataTypePurePolymorphic* New( int id )
{ return new SMDataTypePurePolymorphic( id ); }
String TypeName() const override
{ return String( "'" ) + String( ID() ); }
bool IsPolymorphic() const override
{ return true; }
bool IsEssentiallyNonPolymorphic() const override
{ return false; }
void SetPolymorphicIndex( int id )
{ TypeCode_ = (smTypeCode)-id; }
protected:
SMDataTypePurePolymorphic( int id = 1 )
: SMDataTypeSimple( (smTypeCode)-id )
{}
SMDataTypePurePolymorphic* DeepClone() const override
{ return New( ID() ); }
int ID() const
{ return -TypeCode_.Value(); }
};
template<smTypeCode clsid>
class dtcPrimeDataType : public SMDataTypeSimple
{
protected:
dtcPrimeDataType()
: SMDataTypeSimple(clsid)
{}
public:
static dtcPrimeDataType* New() {
static dtcPrimeDataType type_;
return static_cast<dtcPrimeDataType*>( type_.ShallowClone() );
}
String TypeName() const override
{ return SMTypeCode::GetTypeName(clsid); }
};
using SMDataTypeBool			= dtcPrimeDataType<dtBool>;
using SMDataTypeInteger			= dtcPrimeDataType<dtInt>;
using SMDataTypeFloat			= dtcPrimeDataType<dtFloat>;
using SMDataTypeString			= dtcPrimeDataType<dtString>;
using SMDataTypeDateTime		= dtcPrimeDataType<dtDateTime>;
using SMDataTypeDuration		= dtcPrimeDataType<dtDuration>;
using SMDataTypeMetaType		= dtcPrimeDataType<dtMeta>;
using SMDataTypeMimeResource	= dtcPrimeDataType<dtMimeResource>;
using SMDataTypeXmlTag			= dtcPrimeDataType<dtXmlTag>;
using SMDataTypeDrawing			= dtcPrimeDataType<dtDrawing>;
using SMDataTypeBitmap			= dtcPrimeDataType<dtBitmap>;
using SMDataTypeLibrary			= dtcPrimeDataType<dtLibrary>;
}   
#endif  
namespace WAFL_DataTypes {
class SMDataType
#ifdef DEBUG_DATATYPE_COUNT_ON
: public sml::DebugObjectCounter<SMDataType>
#endif
{
public:
SMDataType()
: Imp_( SMDataTypeUndefined::New() )
{}
explicit SMDataType( SMDataTypeImp* typeImp )
: Imp_( typeImp )
{
if( !Imp_ )
Imp_ = SMDataTypeUndefined::New();
}
SMDataType( const SMDataType& d )
: Imp_( d.Imp_->Clone() )
#ifdef DEBUG_DATATYPE_COUNT_ON
, sml::DebugObjectCounter<SMDataType>(d)
#endif
{}
SMDataType( SMDataType&& d )
: Imp_( d.Imp_ )
#ifdef DEBUG_DATATYPE_COUNT_ON
, sml::DebugObjectCounter<SMDataType>( std::move(d) )
#endif
{
d.Imp_ = SMDataTypeUndefined::New();
}
SMDataType( const char* name )
: SMDataType( PartialRead( name ) )
{}
SMDataType( const String& s )
: SMDataType( s.c_str() )
{}
~SMDataType()
{ Imp_->Free(); }
SMDataType* Clone() const
{ return new SMDataType( *this ); }
void swap( SMDataType& s )
{
std::swap( Imp_, s.Imp_ );
ThrowIfInvalid();
s.ThrowIfInvalid();
}
friend void swap( SMDataType& s1, SMDataType& s2 )
{ s1.swap( s2 ); }
SMDataType& operator = ( const SMDataType& d )
{
#ifdef DEBUG_DATATYPE_COUNT_ON
sml::DebugObjectCounter<SMDataType>::operator=( d );
#endif
ReplaceWithNew( d.Imp_->Clone() );
ThrowIfInvalid();
return *this;
}
SMDataType& operator = ( SMDataType&& d )
{
#ifdef DEBUG_DATATYPE_COUNT_ON
sml::DebugObjectCounter<SMDataType>::operator=( std::move(d) );
#endif
ReplaceWithNew( d.Imp_ );
ThrowIfInvalid();
d.Imp_ = SMDataTypeUndefined::New();
return *this;
}
void ReplaceWithNew( SMDataTypeImp* imp )
{
Imp_->Free();
Imp_ = imp;
ThrowIfInvalid();
}
void ReplaceWithExisting( SMDataTypeImp* imp )
{
imp->AddRef();
ReplaceWithNew( imp );
}
void ReplaceWithNewPolymorphic( int n )
{
ReplaceWithNew( SMDataTypePurePolymorphic::New( n ) );
}
void ReplacePolymorphicSubTypes( int oldPoly, int newPoly );
void ReplacePolymorphicSubTypes( int oldPoly, const SMDataType& t );
String TypeName() const
{ return Imp_->TypeName(); }
const SMTypeCode& TypeCode() const
{ return Imp_->TypeCode(); }
bool IsUndefined() const
{ return TypeCode().IsUndefined(); }
bool IsPurePolymorphic() const
{ return TypeCode().IsPurePolymorphic(); }
bool IsInteger() const
{ return TypeCode().IsInteger(); }
bool IsFloat() const
{ return TypeCode().IsFloat(); }
bool IsString() const
{ return TypeCode().IsString(); }
bool IsDateTime() const
{ return TypeCode().IsDateTime(); }
bool IsBool() const
{ return TypeCode().IsBool(); }
bool IsRecursiveReference() const
{ return TypeCode().IsRecursiveReference(); }
bool IsFunction() const
{ return TypeCode().IsFunction(); }
bool IsFullyDefined() const
{ return Imp_->IsFullyDefined(); }
SMDataType& RecursivelyReferencedType()
{ return Imp_->RecursivelyReferencedType(); }
int TupleArity() const
{ return Imp_->TupleArity(); }
const SMDataType& TupleElementType( unsigned n ) const
{ return Imp_->TupleElementType(n); }
SMDataType& TupleElementType( unsigned n )
{ return const_cast<SMDataType&>( Imp_->TupleElementType(n)); }
SMDataType& TupleSuffixType( unsigned n )
{ return n ? Imp_->TupleSuffixType( n ) : *this; }
const SMDataType& TupleExtensionType() const
{ return Imp_->TupleExtensionType(); }
SMDataType& TupleExtensionType()
{ return Imp_->TupleExtensionType(); }
const SMDataType* RecordElementType( const String& attr ) const
{ return Imp_->RecordElementType( attr ); }
SMDataType* RecordElementType( const String& attr )
{ return Imp_->RecordElementType( attr ); }
SMDataType* RecordExtensionType()
{ return Imp_->RecordExtensionType(); }
void AddRecordAttributesTypeNames( std::map<String,String>& attrs, String& ext ) const
{ Imp_->AddRecordAttributesTypeNames( attrs, ext ); }
void GetRecordAttributeNames( std::set<String>& attrs ) const
{ Imp_->GetRecordAttributeNames( attrs ); }
const std::vector<SMDataType>* GetSetElements() const
{ return Imp_->GetSetElements(); }
int FunctionArity() const
{ return Imp_->FunctionArity(); }
bool IsPolymorphic() const
{ return Imp_->IsPolymorphic(); }
unsigned GetPolymorphicIndex() const
{ return Imp_->GetPolymorphicIndex(); }
bool IsEssentiallyNonPolymorphic() const
{ return Imp_->IsEssentiallyNonPolymorphic(); }
unsigned NormalizePolyTypes();
unsigned NormalizePolyTypes_StoreMapping( unsigned lastUsed, std::map<unsigned, unsigned>& mapping );
static bool PrepareThePolyRemapTable( unsigned& lastUsed, std::map<unsigned, unsigned>& mapping );
void FindMinMaxPolyTypesContinue( unsigned& min, unsigned& max ) const;
void FindMinMaxPolyTypes( unsigned& min, unsigned& max ) const
{
min = max = 0;
FindMinMaxPolyTypesContinue( min, max );
}
void GetPolymorphicSubTypesIndices( std::map<unsigned, unsigned>& used ) const;
bool CheckIfContainsThePolymorphicSubtype( unsigned polyIndex ) const;
void RemapPolyTypes( const std::map<unsigned, unsigned>& mapping );
#ifdef WAFL_DATA_TYPES_USING_SET_TYPES
bool IsSetType() const
{ return _Imp->IsSetType(); }
bool IsSetArgOp() const
{ return _Imp->IsSetArgOp(); }
unsigned GetSetVarIndex() const
{ return _Imp->GetSetVarIndex();  }
unsigned GetSetVarArgIndex() const
{ return _Imp->GetSetVarArgIndex();  }
bool IsUnion() const
{ return _Imp->IsUnion(); }
#endif
bool IsExternal() const
{ return Imp_->IsExternal();  }
SMDataType PartialApplicationType( const std::vector<bool>& specifiedParams ) const;
void DepolymorphizeTupleRecordExtensions();
void DepolymorphizeToInt();
SMDataType& CollectionElementType()
{ return Imp_->CollectionElementType(); }
const SMDataType& CollectionElementType() const
{ return const_cast<SMDataType*>(this)->CollectionElementType(); }
SMDataType& CollectionIndexType()
{ return Imp_->CollectionIndexType(); }
const SMDataType& CollectionIndexType() const
{ return const_cast<SMDataType*>(this)->CollectionIndexType(); }
SMDataType& AbstractInstanceType()
{ return Imp_->AbstractInstanceType(); }
const SMDataType& AbstractInstanceType() const
{ return const_cast<SMDataType*>(this)->AbstractInstanceType(); }
SMDataType& FunctionArgumentType( unsigned n )
{ return Imp_->FunctionArgumentType(n); }
const SMDataType& FunctionArgumentType( unsigned n ) const
{ return const_cast<SMDataType*>(this)->FunctionArgumentType(n); }
SMDataType& FunctionResultType()
{ return FunctionArgumentType(0); }
const SMDataType& FunctionResultType() const
{ return FunctionArgumentType(0); }
SMDataType& TypeOperatorOperandType( unsigned n )
{ return Imp_->TypeOperatorOperandType(n); }
bool IsSameCategoryAs( const SMDataType& dt ) const
{ return *(long*)Imp_ == *(long*)dt.Imp_; }
int Compare( const SMDataType& dt ) const
{ return Imp_->Compare( *dt.Imp_ ); }
bool operator < ( const SMDataType& dt ) const
{ return *Imp_ < *dt.Imp_; }
bool operator <= ( const SMDataType& dt ) const
{ return *Imp_ <= *dt.Imp_; }
bool operator > ( const SMDataType& dt ) const
{ return *Imp_ > *dt.Imp_; }
bool operator >= ( const SMDataType& dt ) const
{ return *Imp_ >= *dt.Imp_; }
bool operator == ( const SMDataType& dt ) const
{ return *Imp_ == *dt.Imp_; }
bool operator != ( const SMDataType& dt ) const
{ return *Imp_ != *dt.Imp_; }
static int FindExternalType( const char* typeName );
static int RegisterExternalType( const char* typeName );
static const String& GetExternalTypeName( int n )
{ return ExternalTypeNames_[n - 1 - dtFirstExternal]; }
bool HasSubTypes() const
{ return Imp_->HasSubTypes(); }
void GetSubTypes( std::vector<SMDataType*>& fill )
{ return Imp_->GetSubTypes( fill ); }
void GetSubTypes( std::vector<const SMDataType*>& fill ) const
{ return Imp_->GetSubTypes( fill ); }
void GetAllPolymorphicSubTypes( std::vector<SMDataType*>& fill );
#ifdef WAFL_DATA_TYPES_USING_SET_TYPES
void AddTypeToSet( const SMDataType& dt );
void AddTypeToUnion( const SMDataType& dt );
#endif
bool AcceptVisitorNoTraverse( SMDataTypeVisitor& aVisitor )
{ return AcceptVisitor( aVisitor, 0 ); }
bool AcceptVisitorShallowTraverse( SMDataTypeVisitor& aVisitor )
{ return AcceptVisitor( aVisitor, 1 ); }
bool AcceptVisitorDeepTraverse( SMDataTypeVisitor& aVisitor )
{ return AcceptVisitor( aVisitor, -1 ); }
bool AcceptVisitor( SMDataTypeVisitor& aVisitor, unsigned depth )
{
SMDataTypeVisitor::tState state = aVisitor.ProcessTheType( *this );
if( state == SMDataTypeVisitor::sContinue && depth > 0 )
return TraverseVisitor( aVisitor, depth - 1 );
else
return ( state != SMDataTypeVisitor::sTerminate );
}
bool TraverseVisitor( SMDataTypeVisitor& aVisitor, unsigned depth )
{ return Imp_->TraverseVisitor( aVisitor, depth ); }
bool ShallowTraverseVisitor( SMDataTypeVisitor& aVisitor )
{ return TraverseVisitor( aVisitor, 0 ); }
bool DeepTraverseVisitor( SMDataTypeVisitor& aVisitor )
{ return TraverseVisitor( aVisitor, -1 ); }
bool ForAllSubtypes( std::function<bool( const SMDataType& )> cond ) const
{ return Imp_->ForAllSubtypes( cond ); }
void ThrowIfInvalid() const
{
if( !ForAllSubtypes( [this]( const SMDataType& subtype ) { return &subtype != this;  } ) )
throw "ERROR";
}
protected:
static SMDataTypeImp* PartialRead( const char* );
public:
enum eTypeStatus {
notChecked=0,
checked=1,
alwaysChecking,     
checkingRightNow    
};
static const SMDataType
Undefined,
Integer, Float, Bool, Str,
DateTime, Duration, MetaType,
List, Array, Map, VariableSet, MimeResource;
static const SMDataType
BoolFunction, IntegerFunction, FloatFunction, StringFunction, DateTimeFunction, DurationFunction,
NumericFunction, ListFunction, ListToValueFunction,
BoolFunction0, IntegerFunction0, FloatFunction0, StringFunction0, DateTimeFunction0, DurationFunction0,
FnI2F, FnB2F, FnS2F,
FnF2I, FnB2I, FnS2I,
FnI2B, FnF2B, FnS2B,
FnI2S, FnF2S, FnB2S,
FnX2X,
BoolOperator, IntegerOperator, FloatOperator, StringOperator, DateTimeOperator, DurationOperator,
NumericOperator, StrNumOperator,
RelationOperator;
static const SMDataType
Polymorphic,
RecursiveReference,
ExactTuple[],
ExtendableTuple[],
Fnc[],
Application[];
static const SMDataType
Library,
Transaction, SqlQuery, SqlCommand,
Drawing, Bitmap, XmlTag;
static SMDataTypeImp* NewExactTuple( unsigned arity, unsigned polyIndexFrom );
static SMDataTypeImp* NewExtendableTuple( unsigned arity, unsigned polyIndexFrom );
static SMDataTypeImp* ExactRecord( const std::map<String,SMDataType>& elements );
static SMDataTypeImp* ExtendableRecord( const std::map<String,SMDataType>& elements, int extPolyIndex );
private:
SMDataTypeImp* Imp_;		
static String			ExternalTypeNames_[ dtLastAllowedExternal - dtFirstExternal + 1 ];
static smTypeCode_int	NextExternalType_;
friend class SMTypeCheckingEnvironment;
friend class SMDataType_Tester;
};
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libEvaluator/MemoryPool.h
#ifndef EvMemoryPoolH
#define EvMemoryPoolH
namespace WAFL_Evaluator {
class EvCell;
constexpr unsigned t_Wafl_EvCell_Size = 2 * t_Wafl_Word_Size;
template <
unsigned short	sz_AtomSizeInCells = 1,	
unsigned		sz_ZoneSize = 0			
>
class EvCellMemoryPool : public smm::HeapMemoryPool<
EvCell,
sz_AtomSizeInCells * t_Wafl_EvCell_Size,
sz_ZoneSize,
smm::MemoryPoolPolicy::defaultPolicy
- smm::MemoryPoolPolicy::zoneMgr_local
+ smm::MemoryPoolPolicy::zoneMgr_global
>
{
public:
using tParentType = smm::HeapMemoryPool<
EvCell,
sz_AtomSizeInCells * t_Wafl_EvCell_Size,
sz_ZoneSize,
smm::MemoryPoolPolicy::defaultPolicy
- smm::MemoryPoolPolicy::zoneMgr_local
+ smm::MemoryPoolPolicy::zoneMgr_global
>;
EvCellMemoryPool( const char* name )
: tParentType( name )
{}
static constexpr size_t sizeInCells() {
return sz_AtomSizeInCells;
}
};
template <int Size_, int _ZoneSize = 0>
class EvCellMemoryPoolHolder
{
public:
using tPool = EvCellMemoryPool<Size_, _ZoneSize>;
thread_local
static tPool Pool;
static constexpr size_t sizeInCells() {
return tPool::sizeInCells();
}
};
template< class T >
constexpr auto best_EvCellMemoryPoolHolder_size_for()
{
return ( sizeof( T ) + t_Wafl_EvCell_Size - 1 ) / t_Wafl_EvCell_Size;
}
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libEvaluator/../libMemory/UniversalMemoryPool.h
#ifndef SMM_UniversalMemoryPoolH
#define SMM_UniversalMemoryPoolH
namespace smm {
using UniversalHeapMemoryPool_BaseClass = smm::MemoryPoolWithUsageCounter<
false
#ifndef NDEBUG
#ifdef DEBUG_ENABLE_SMLIB_MEMORY_TRACKING
| true
#endif
#endif
>;
class UniversalHeapMemoryPoolBase : public UniversalHeapMemoryPool_BaseClass
{
public:
UniversalHeapMemoryPoolBase( const char* poolname )
: UniversalHeapMemoryPool_BaseClass( 0, poolname ),
PoolDescription_( 0, poolname, MemoryPoolPolicy::defaultPolicy ),
Pool_8_	( std::string( "UMPB_" ) + poolname + '_' + std::to_string(8)),
Pool_12_	( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 12 )),
Pool_16_	( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 16 )),
Pool_24_	( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 24 )),
Pool_32_	( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 32 )),
Pool_48_	( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 48 )),
Pool_64_	( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 64 )),
Pool_96_	( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 96 )),
Pool_128_	( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 128 )),
Pool_192_	( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 192 )),
Pool_256_	( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 256 )),
Pool_384_	( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 384 )),
Pool_512_	( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 512 )),
Pool_768_	( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 768 )),
Pool_1024_( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 1024 )),
Pool_1536_( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 1536 )),
Pool_2048_( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 2048 )),
Pool_3072_( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 3072 )),
Pool_4096_( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 4096 )),
Pool_6144_( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 6144 )),
Pool_8192_( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 8192 )),
Pool_12288_( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 12288 )),
Pool_16384_( std::string( "UMPB_" ) + poolname + '_' + std::to_string( 16384 ))
{}
~UniversalHeapMemoryPoolBase()
{}
char* AllocBytes( size_t freeBlockSize )
{ return AllocBytesAndUserInfoBlock( freeBlockSize, 0 ); }
char* AllocBytesAndUserInfoBlock( size_t freeBlockSize, unsigned short userInfoBlockSize );
void FreeBytes( char* aFreeBlock );
protected:
template<unsigned long freeBlockSize, unsigned short userInfoBlockSize = 0>
char* AllocBytesX();
template<unsigned long freeBlockSize, unsigned short userInfoBlockSize=0>
void FreeBytesX( char* aFreeBlock );
template<unsigned long freeBlockSize, unsigned short userInfoBlockSize = 0>
static char* getUserInfoBlockPtr_( char* freeBlock )
{ return freeBlock - userInfoBlockSize; }
private:
struct umpInfoBlock {
size_t			AllocatedBlockSize;		
unsigned short	BothInfoBlocksSize;		
};
static umpInfoBlock& _getUmpInfoBlock( char* freeBlock )
{ return *(umpInfoBlock*)( freeBlock - sizeof(umpInfoBlock) ); }
static size_t _getAllocatedBlockSize( char* freeBlock )
{ return _getUmpInfoBlock(freeBlock).AllocatedBlockSize; }
static unsigned short _getTotalInfoBlockSize( char* freeBlock )
{ return _getUmpInfoBlock(freeBlock).BothInfoBlocksSize; }
static unsigned short _getUserInfoBlockSize( char* freeBlock )
{ return _getTotalInfoBlockSize(freeBlock) - sizeof(umpInfoBlock); }
static size_t _getFreeBlockSize( char* freeBlock )
{ return _getAllocatedBlockSize(freeBlock) - _getTotalInfoBlockSize(freeBlock); }
static char* _getAllocatedBlockPtr( char* freeBlock )
{ return freeBlock - _getTotalInfoBlockSize(freeBlock); }
public:
static char* getUserInfoBlockPtr_( char* freeBlock )
{ return _getAllocatedBlockPtr( freeBlock ); }
const MemoryPoolDescription& Description() const override
{ return PoolDescription_; }
private:
UniversalHeapMemoryPoolBase( const UniversalHeapMemoryPoolBase& ) = delete;
UniversalHeapMemoryPoolBase( UniversalHeapMemoryPoolBase&& ) = delete;
UniversalHeapMemoryPoolBase& operator= ( const UniversalHeapMemoryPoolBase& ) = delete;
UniversalHeapMemoryPoolBase& operator= ( UniversalHeapMemoryPoolBase&& ) = delete;
MemoryPoolDescription	PoolDescription_;
constexpr static MemoryPoolPolicy PoolPolicy =
smm::MemoryPoolPolicy::defaultPolicy
- smm::MemoryPoolPolicy::zoneMgr_local
+ smm::MemoryPoolPolicy::zoneMgr_global;
HeapMemoryPool<long, 8, 0, PoolPolicy>		Pool_8_;
HeapMemoryPool<long, 12, 0, PoolPolicy>		Pool_12_;
HeapMemoryPool<long, 16, 0, PoolPolicy>		Pool_16_;
HeapMemoryPool<long, 24, 0, PoolPolicy>		Pool_24_;
HeapMemoryPool<long, 32, 0, PoolPolicy>		Pool_32_;
HeapMemoryPool<long, 48, 0, PoolPolicy>		Pool_48_;
HeapMemoryPool<long, 64, 0, PoolPolicy>		Pool_64_;
HeapMemoryPool<long, 96, 0, PoolPolicy>		Pool_96_;
HeapMemoryPool<long, 128, 0, PoolPolicy>	Pool_128_;
HeapMemoryPool<long, 192, 0, PoolPolicy>	Pool_192_;
HeapMemoryPool<long, 256, 0, PoolPolicy>	Pool_256_;
HeapMemoryPool<long, 384, 0, PoolPolicy>	Pool_384_;
HeapMemoryPool<long, 512, 0, PoolPolicy>	Pool_512_;
HeapMemoryPool<long, 768, 0, PoolPolicy>	Pool_768_;
HeapMemoryPool<long, 1024, 0, PoolPolicy>	Pool_1024_;
HeapMemoryPool<long, 1536, 0, PoolPolicy>	Pool_1536_;
HeapMemoryPool<long, 2048, 0, PoolPolicy>	Pool_2048_;
HeapMemoryPool<long, 3072, 0, PoolPolicy>	Pool_3072_;
HeapMemoryPool<long, 4096, 0, PoolPolicy>	Pool_4096_;
HeapMemoryPool<long, 6144, 0, PoolPolicy>	Pool_6144_;
HeapMemoryPool<long, 8192, 0, PoolPolicy>	Pool_8192_;
HeapMemoryPool<long, 12288, 0, PoolPolicy>	Pool_12288_;
HeapMemoryPool<long, 16384, 0, PoolPolicy>	Pool_16384_;
friend class MemoryPoolTest;
};
template<unsigned long freeBlockSize, unsigned short userInfoBlockSize>
char* UniversalHeapMemoryPoolBase::AllocBytesX()
{
constexpr unsigned long toAllocate = freeBlockSize + userInfoBlockSize;
char* allocated;
#define TMP_DOALLOC(n) \
if( toAllocate<=n ) allocated = (char*)Pool_##n##_.Alloc();
TMP_DOALLOC( 8 )
else TMP_DOALLOC( 12 )
else TMP_DOALLOC( 16 )
else TMP_DOALLOC( 24 )
else TMP_DOALLOC( 32 )
else TMP_DOALLOC( 48 )
else TMP_DOALLOC( 64 )
else TMP_DOALLOC( 96 )
else TMP_DOALLOC( 128 )
else TMP_DOALLOC( 192 )
else TMP_DOALLOC( 256 )
else TMP_DOALLOC( 384 )
else TMP_DOALLOC( 512 )
else TMP_DOALLOC( 768 )
else TMP_DOALLOC( 1024 )
else TMP_DOALLOC( 1536 )
else TMP_DOALLOC( 2048 )
else TMP_DOALLOC( 3072 )
else TMP_DOALLOC( 4096 )
else TMP_DOALLOC( 6144 )
else TMP_DOALLOC( 8192 )
else TMP_DOALLOC( 12288 )
else TMP_DOALLOC( 16384 )
else allocated = new char[toAllocate];
#undef TMP_DOALLOC
return allocated + userInfoBlockSize;
}
template<unsigned long freeBlockSize, unsigned short userInfoBlockSize>
void UniversalHeapMemoryPoolBase::FreeBytesX( char* aFreeBlock )
{
#ifdef DEBUG_ENABLE_SMLIB_MEMORY_TRACKING
AnnotateFree();
#endif
constexpr unsigned long allocatedSize = freeBlockSize + userInfoBlockSize;
char* allocated = aFreeBlock - userInfoBlockSize;
#define TMP_DOFREE(n) \
if( allocatedSize <= n ) Pool_##n##_.Free( allocated );
TMP_DOFREE( 8 )
else TMP_DOFREE( 12 )
else TMP_DOFREE( 16 )
else TMP_DOFREE( 24 )
else TMP_DOFREE( 32 )
else TMP_DOFREE( 48 )
else TMP_DOFREE( 64 )
else TMP_DOFREE( 96 )
else TMP_DOFREE( 128 )
else TMP_DOFREE( 192 )
else TMP_DOFREE( 256 )
else TMP_DOFREE( 384 )
else TMP_DOFREE( 512 )
else TMP_DOFREE( 768 )
else TMP_DOFREE( 1024 )
else TMP_DOFREE( 1536 )
else TMP_DOFREE( 2048 )
else TMP_DOFREE( 3072 )
else TMP_DOFREE( 4096 )
else TMP_DOFREE( 6144 )
else TMP_DOFREE( 8192 )
else TMP_DOFREE( 12288 )
else TMP_DOFREE( 16384 )
else delete [] allocated;
#undef TMP_DOFREE
}
template <
class t_BaseAtomType,										
unsigned sz_BaseAtomSizeInBytes = sizeof( t_BaseAtomType )	
>
class UniversalHeapMemoryPool : public UniversalHeapMemoryPoolBase
{
public:
using tAtom = t_BaseAtomType;
static constexpr unsigned singleAtomSizeInBytes()
{
return
sz_BaseAtomSizeInBytes && sz_BaseAtomSizeInBytes >= sizeof( t_BaseAtomType )
? sz_BaseAtomSizeInBytes
: sizeof( t_BaseAtomType );
}
UniversalHeapMemoryPool( const char* poolname )
: UniversalHeapMemoryPoolBase( poolname )
{}
~UniversalHeapMemoryPool()
{}
tAtom* Alloc( size_t size )
{ return (tAtom*)AllocBytes( sizeof( tAtom ) * size ); }
template<class userInfoBlock>
tAtom* AllocWithInfoBlock( unsigned long size )
{
return (tAtom*)AllocBytesAndUserInfoBlock( sizeof( tAtom ) * size, sizeof( userInfoBlock ) );
}
void Free( tAtom* atom )
{ FreeBytes( (char*)atom ); }
protected:
template<unsigned long size>
tAtom* AllocX()
{ return (tAtom*)AllocBytesX< sizeof( tAtom ) * size>() ; }
template<unsigned long freeBlockSize>
void FreeX( tAtom* atom )
{ FreeBytesX<freeBlockSize>( (char*)atom ); }
private:
friend class MemoryPoolTest;
};
}   
#endif  
#include <iostream>
namespace WAFL_Evaluator {
using sml::String;
using WAFL_DataTypes::SMDataType;
class EvCellMetaProcessor;
#ifdef ENABLE_EXCEPTION_HANDLING_DISABLING
#endif
#ifdef DEBUG_ENABLE_TRACE
#undef EVCELL_TRACELOG
#undef EVCELL_TRACELOG1
#ifdef DEBUG_ENABLE_TRACE_IN_CELL_EVALUATION
#define EVCELL_TRACELOG() CurrentEvC().LogDebug( String("TRACE: ") + __FUNCTION__ + " : " + __FILE__ + " : " + __LINE__ )
#define EVCELL_TRACELOG1(x) CurrentEvC().LogDebug( String("TRACE: ") + __FUNCTION__ + " [" + x + "] : " + __FILE__ + " : " + __LINE__ )
#else
#define EVCELL_TRACELOG()
#define EVCELL_TRACELOG1(x)
#endif
#undef EVCELL_TRACEEXCEPTION
#define EVCELL_TRACEEXCEPTION() CurrentEvC_Report().LogError( String("EXCEPTION AT: ") + __FUNCTION__ + " : " + __FILE__ + " : " + __LINE__ )
#else
#define EVCELL_TRACELOG()
#define EVCELL_TRACELOG1(x)
#define EVCELL_TRACEEXCEPTION()
#endif
class EvCell;
class EvArrayCellData;
static_assert( t_Wafl_EvCell_Size == 2 * t_Wafl_Word_Size, "Wrong Cell size definition!" );
using fInternal = t_Wafl_Word;			
using fInteger	= t_Wafl_Signed_Word;	
using fUnsigned = t_Wafl_Word;			
using fBool		= unsigned long;		
using fCellPtr	= const EvCell*;		
#if defined(WAFL_WORD_SIZE_32)
using fFloat = float;				
#else
using fFloat = double;				
#endif
#ifdef WAFL_EVALUATOR_USING_LAZY_STRINGS
using fString = sml::LazyString;
#else
using fString = sml::String;
#endif
#define DECLARE_GENERAL_EVALUATION_METHODS                      \
void __fastcall Evaluate() const override;                  \
void __fastcall EvaluateTo( EvCell* ) const override;       \
EvCell* __fastcall EvaluatePtr() const override;
#define DECLARE_PRIMITIVE_EVALUATION_METHODS                    \
fInteger __fastcall EvaluateInteger() const override;		\
fFloat __fastcall EvaluateFloat() const override;           \
fBool __fastcall EvaluateBool() const override;             \
void __fastcall EvaluateString( fString& s ) const override
#define DECLARE_EVALUATION_METHODS			\
DECLARE_GENERAL_EVALUATION_METHODS      \
DECLARE_PRIMITIVE_EVALUATION_METHODS
#if defined(WAFL_COMPILER_CLANG)
template<> thread_local EvCellMemoryPool<1> EvCellMemoryPoolHolder<1>::Pool;
template<> thread_local EvCellMemoryPool<2> EvCellMemoryPoolHolder<2>::Pool;
template<> thread_local EvCellMemoryPool<3> EvCellMemoryPoolHolder<3>::Pool;
template<> thread_local EvCellMemoryPool<4> EvCellMemoryPoolHolder<4>::Pool;
template<> thread_local EvCellMemoryPool<5> EvCellMemoryPoolHolder<5>::Pool;
template<> thread_local EvCellMemoryPool<6> EvCellMemoryPoolHolder<6>::Pool;
template<> thread_local EvCellMemoryPool<7> EvCellMemoryPoolHolder<7>::Pool;
template<> thread_local EvCellMemoryPool<8> EvCellMemoryPoolHolder<8>::Pool;
template<> thread_local EvCellMemoryPool<9> EvCellMemoryPoolHolder<9>::Pool;
template<> thread_local EvCellMemoryPool<10> EvCellMemoryPoolHolder<10>::Pool;
template<> thread_local EvCellMemoryPool<11> EvCellMemoryPoolHolder<11>::Pool;
template<> thread_local EvCellMemoryPool<12> EvCellMemoryPoolHolder<12>::Pool;
template<> thread_local EvCellMemoryPool<13> EvCellMemoryPoolHolder<13>::Pool;
template<> thread_local EvCellMemoryPool<14> EvCellMemoryPoolHolder<14>::Pool;
template<> thread_local EvCellMemoryPool<15> EvCellMemoryPoolHolder<15>::Pool;
template<> thread_local EvCellMemoryPool<16> EvCellMemoryPoolHolder<16>::Pool;
template<> thread_local EvCellMemoryPool<17> EvCellMemoryPoolHolder<17>::Pool;
template<> thread_local EvCellMemoryPool<18> EvCellMemoryPoolHolder<18>::Pool;
template<> thread_local EvCellMemoryPool<19> EvCellMemoryPoolHolder<19>::Pool;
template<> thread_local EvCellMemoryPool<20> EvCellMemoryPoolHolder<20>::Pool;
template<> thread_local EvCellMemoryPool<21> EvCellMemoryPoolHolder<21>::Pool;
#endif
class EvCell
{
public:
EvCell()
{}
virtual void __fastcall Evaluate() const;
virtual void __fastcall EvaluateTo( EvCell* reserved ) const;
virtual EvCell* __fastcall EvaluatePtr() const;
virtual fInteger __fastcall EvaluateInteger() const;
virtual fFloat __fastcall EvaluateFloat() const;
virtual fBool __fastcall EvaluateBool() const;
virtual void __fastcall EvaluateString( fString& s ) const;
virtual void __fastcall EvaluateApplication() const
{ Evaluate(); }
virtual void __fastcall EvaluateApplicationTo( EvCell* reserved ) const
{ EvaluateTo( reserved ); }
virtual EvCell* __fastcall EvaluateApplicationPtr() const
{ return EvaluatePtr(); }
virtual fInteger __fastcall EvaluateIntegerApplication() const;
virtual fFloat __fastcall EvaluateFloatApplication() const;
virtual fBool __fastcall EvaluateBoolApplication() const;
virtual void __fastcall EvaluateStringApplication( fString& s ) const;
virtual const EvCell& __fastcall EvaluateElement( const EvCell& indexExp ) const;
virtual void __fastcall EvaluateRecordAttribute( const String& attrName ) const;
virtual void __fastcall EvaluateRecordAttributes( std::vector<String>& attrs ) const;
virtual EvCell* __fastcall GetTargetIfIndirection()
{ return this; }
virtual EvCell* __fastcall GetTupleWithUpdatedAttribute( const unsigned* attrChain, unsigned n, EvCell* value ) const;
virtual bool __fastcall HasRecordAttribute( const String& attrName ) const
{ return false; }
virtual EvCell* __fastcall GetRecordWithUpdatedAttribute( const String* attrChain, unsigned n, EvCell* value ) const;
virtual const SMDataType& GetPrimeType() const
{ return SMDataType::Undefined; }
virtual bool IsListCell() const
{ return false; }
virtual fString metaGetSourceCode( bool derefArgs ) const
{ return "CELL[***NOT DEFINED***]"; }
virtual fString metaGetAEG( EvCellMetaProcessor& mp, unsigned depth ) const;
virtual void metaGetDataType( SMDataType& dt ) const
{ dt = SMDataType::Undefined; }
SMDataType metaGetType() const
{
SMDataType dt;
metaGetDataType( dt );
return dt;
}
fString metaGetCellName() const;
bool HasTheSameCellTypeAs( const EvCell* c ) const
{ return GetVTable() == c->GetVTable(); }
bool IsBinaryEqualTo( const EvCell* c ) const
{
return HasTheSameCellTypeAs( c )
&& InternalValue() == c->InternalValue();
}
virtual bool IsContentEqualTo( const EvCell* c ) const
{
return HasTheSameCellTypeAs( c )
&& InternalValue() == c->InternalValue();
}
virtual int metaCompare( const EvCell& c ) const
{
return
GetVTable() < c.GetVTable()
? -1
: GetVTable() > c.GetVTable()
? 1
: InternalValue() < c.InternalValue()
? -1
: InternalValue() > c.InternalValue()
? 1
: 0;
}
virtual ~EvCell()
{}
virtual void ClearCell()
{}
virtual void ForceFullEvaluation()
{}
protected:
EvCell( const EvCell& c )
: Value_( c.InternalValue() )
{
CopyVTableFrom( c );
Instantiate();
}
fInternal GetVTable() const
{ return *(fInternal*)this; }
void CopyVTableFrom( const EvCell& c )
{ *(fInternal*)this = *(fInternal*)&c; }
void CopyVTableTo( EvCell& c ) const
{ *(fInternal*) &c = *(fInternal*) this; }
void CopyContentFrom( const EvCell& c )
{ Value_ = c.Value_; }
void CopyContentTo( EvCell& c ) const
{ c.Value_ = Value_; }
void CopyVTableAndContentFrom( const EvCell& c )
{
CopyVTableFrom( c );
CopyContentFrom( c );
}
void CopyVTableAndContentTo( EvCell& c ) const
{
CopyVTableTo( c );
CopyContentTo( c );
}
public:
void CopyToReserved( EvCell* reserved ) const
{
CopyVTableAndContentTo( *reserved );
reserved->Instantiate();
}
void CopyToReserved( EvCell& reserved ) const
{ CopyToReserved( &reserved ); }
void CopyToReservedWithoutInstantiation( EvCell* reserved ) const
{
CopyVTableAndContentTo( *reserved );
}
EvCell* Clone() const
{
EvCell* c = AllocateNewCell();
CopyToReserved( c );
return c;
}
EvCell* CreateStagedCopy()
{
EvCell* c = AllocateNewCell();
CreateStagedCopyAt( c );
return c;
}
virtual void CreateStagedCopyAt( EvCell* reserved )
{
CopyToReserved( reserved );
}
virtual EvCell* GetStagedBaseCell()
{ return this; }
virtual bool IsStagedCopy() const
{ return false; }
void CopyFrom( const EvCell* c )
{
if( this != c ) {
ClearCell();
CopyVTableAndContentFrom( *c );
Instantiate();
}
}
void CopyFrom( const EvCell& c )
{ CopyFrom(&c); }
void CopyTo( EvCell* c ) const
{ c->CopyFrom( this ); }
void CopyTo( EvCell& c ) const
{ CopyTo(&c); }
void operator=( const EvCell& c )
{ CopyFrom(&c); }
EvCell* MoveFromReserved()
{
EvCell* c = AllocateNewCell();
CopyVTableAndContentTo( *c );
return c;
}
void MoveToReserved( EvCell* reserved ) const
{
CopyVTableAndContentTo( *reserved );
DeallocateCell( this );
}
void MoveFromReservedToReserved( EvCell* c )
{
CopyVTableAndContentTo( *c );
}
virtual EvCell* CreateNewCellOfSameClass() const
{ return nullptr; }
protected:
virtual void Instantiate()
{}
#ifdef MSVC
private:
void* operator new( size_t ) = delete;
void operator delete( void* c ) = delete;
#else
void* operator new( size_t ) = delete;
public:
void operator delete( void* c )
{
std::cerr << "Terminated! EvCell::delete called\n";
std::terminate();
}
#endif
public:
static EvCell* AllocateNewCell()
{ return (EvCell*)SingleCellMemoryPool().Alloc(); }
static void DeallocateCell( const EvCell* c )
{ SingleCellMemoryPool().Free(c); }
template<class T,typename... Args>
static T* NewCell(Args&&... args)
{ return ::new (AllocateNewCell()) T( std::forward<Args>( args )... ); }
template<class T,typename... Args>
static T* CreateAt( void* addr, Args&&... args )
{ return ::new (addr) T( std::forward<Args>( args )... ); }
void DeleteCell() const
{
const_cast<EvCell*>( this )->ClearCell();
DeallocateCell( this );
}
virtual bool IsLastObjectReference() const
{ return true; }
fInteger AsInteger() const
{ return *(fInteger*)&Value_; }
fFloat AsFloat() const
{ return *(fFloat*)&Value_; }
fBool AsBool() const
{ return *(fBool*)&Value_; }
fCellPtr ValueAsCellPtr() const
{return *(fCellPtr*)&Value_; }
fCellPtr& ValueAsCellPtr()
{return *(fCellPtr*)&Value_; }
void AsString( fString& result ) const
{ result = *(fString*)&Value_; }
const fString& AsString() const
{ return *(fString*)&Value_; }
virtual const EvArrayCellData* GetValuesArray() const
{ return 0; }
virtual fInteger Compare( const EvCell& c ) const
{ return AsInteger() - c.AsInteger(); }
bool operator == ( const EvCell& c ) const
{ return !Compare(c); }
bool operator != ( const EvCell& c ) const
{ return Compare(c); }
bool operator >= ( const EvCell& c ) const
{ return Compare(c) >= 0; }
bool operator <= ( const EvCell& c ) const
{ return Compare(c) <= 0; }
bool operator > ( const EvCell& c ) const
{ return Compare(c) > 0; }
bool operator < ( const EvCell& c ) const
{ return Compare(c) < 0; }
fInteger UniversalCompare( const EvCell& c ) const
{
fInteger result = *(fInteger*)this - *(fInteger*)&c;
return result ? result : Compare( c );
}
virtual String DisplayString( bool encodeStr = true ) const
{
return String("*EvCell[") + GetVTable() + ":" + AsInteger() + "]*";
}
virtual String DisplayShortString( bool encodeStr = true ) const
{
return DisplayString( encodeStr );
}
virtual bool IsContextFree() const
{ return true; }
virtual int metaArity() const
{ return 0; }
virtual bool metaIsMetaOperator() const
{ return false; }
virtual bool metaIsFunctionApplication() const
{ return false; }
virtual bool metaUse() const
{ return false; }
protected:
EvCell( fInternal v )
: Value_(v)
{}
explicit EvCell( fCellPtr c )
: Value_( (fInternal)c )
{}
fInternal InternalValue() const
{ return Value_; }
fInternal& InternalValue()
{ return Value_; }
void SetValue( const fCellPtr c )
{ *(fCellPtr*)&Value_ = c; }
fInternal   Value_;		
protected:
static EvCellMemoryPool<1>& SingleCellMemoryPool()
{ return EvCellMemoryPoolHolder<1>::Pool; }
public:
static const smm::MemoryPool& MemoryPool()
{ return SingleCellMemoryPool(); }
static constexpr size_t bestFittingPoolSizeFor( size_t nOfBytes ) {
return ( nOfBytes + sizeof( EvCell ) - 1 ) / sizeof( EvCell );
}
using CellUniversalMP = smm::UniversalHeapMemoryPool<EvCell, t_Wafl_EvCell_Size>;
thread_local
static CellUniversalMP		UniversalCellMemoryPool;
};
class EvInvalidCell : public EvCell
{
public:
static EvInvalidCell Prototype;
static t_Wafl_Word VirtTable;
DECLARE_GENERAL_EVALUATION_METHODS;
};
class PassiveCellHolder
{
public:
t_Wafl_Word virtTable;
t_Wafl_Word value;
template< typename T >
T* AsPtr()
{ return (T*)this; }
EvCell* AsCellPtr()
{ return (EvCell*)this; }
const EvCell* AsCellPtr() const
{ return (const EvCell*)this; }
fInteger AsInteger() const
{ return AsCellPtr()->AsInteger(); }
fFloat AsFloat() const
{ return AsCellPtr()->AsFloat(); }
fBool AsBool() const
{ return AsCellPtr()->AsBool(); }
const fString& AsString() const
{ return AsCellPtr()->AsString(); }
void AsString( fString& s ) const
{ return AsCellPtr()->AsString( s ); }
void Clean()
{ ((EvCell*)this)->ClearCell(); }
void CopyVTableFrom( EvCell* c )
{ virtTable = *(t_Wafl_Word*) c; }
void SetVTable( t_Wafl_Word p )
{ virtTable = p; }
};
#if defined(WAFL_COMPILER_MSVC)
template<> thread_local EvCellMemoryPool<1> EvCellMemoryPoolHolder<1>::Pool( "Seq./Op. Pool 1" );
template<> thread_local EvCellMemoryPool<2> EvCellMemoryPoolHolder<2>::Pool( "Seq./Op. Pool 2" );
template<> thread_local EvCellMemoryPool<3> EvCellMemoryPoolHolder<3>::Pool( "Seq./Op. Pool 3" );
template<> thread_local EvCellMemoryPool<4> EvCellMemoryPoolHolder<4>::Pool( "Seq./Op. Pool 4" );
template<> thread_local EvCellMemoryPool<5> EvCellMemoryPoolHolder<5>::Pool( "Seq./Op. Pool 5" );
template<> thread_local EvCellMemoryPool<6> EvCellMemoryPoolHolder<6>::Pool( "Seq./Op. Pool 6" );
template<> thread_local EvCellMemoryPool<7> EvCellMemoryPoolHolder<7>::Pool( "Seq./Op. Pool 7" );
template<> thread_local EvCellMemoryPool<8> EvCellMemoryPoolHolder<8>::Pool( "Seq./Op. Pool 8" );
template<> thread_local EvCellMemoryPool<9> EvCellMemoryPoolHolder<9>::Pool( "Seq./Op. Pool 9" );
template<> thread_local EvCellMemoryPool<10> EvCellMemoryPoolHolder<10>::Pool( "Seq./Op. Pool 10" );
template<> thread_local EvCellMemoryPool<11> EvCellMemoryPoolHolder<11>::Pool( "Seq./Op. Pool 11" );
template<> thread_local EvCellMemoryPool<12> EvCellMemoryPoolHolder<12>::Pool( "Seq./Op. Pool 12" );
template<> thread_local EvCellMemoryPool<13> EvCellMemoryPoolHolder<13>::Pool( "Seq./Op. Pool 13" );
template<> thread_local EvCellMemoryPool<14> EvCellMemoryPoolHolder<14>::Pool( "Seq./Op. Pool 14" );
template<> thread_local EvCellMemoryPool<15> EvCellMemoryPoolHolder<15>::Pool( "Seq./Op. Pool 15" );
template<> thread_local EvCellMemoryPool<16> EvCellMemoryPoolHolder<16>::Pool( "Seq./Op. Pool 16" );
template<> thread_local EvCellMemoryPool<17> EvCellMemoryPoolHolder<17>::Pool( "Seq./Op. Pool 17" );
template<> thread_local EvCellMemoryPool<18> EvCellMemoryPoolHolder<18>::Pool( "Seq./Op. Pool 18" );
template<> thread_local EvCellMemoryPool<19> EvCellMemoryPoolHolder<19>::Pool( "Seq./Op. Pool 19" );
template<> thread_local EvCellMemoryPool<20> EvCellMemoryPoolHolder<20>::Pool( "Seq./Op. Pool 20" );
template<> thread_local EvCellMemoryPool<21> EvCellMemoryPoolHolder<21>::Pool( "Seq./Op. Pool 21" );
#elif !defined(WAFL_COMPILER_CLANG)
template<> thread_local EvCellMemoryPool<1> EvCellMemoryPoolHolder<1>::Pool;
template<> thread_local EvCellMemoryPool<2> EvCellMemoryPoolHolder<2>::Pool;
template<> thread_local EvCellMemoryPool<3> EvCellMemoryPoolHolder<3>::Pool;
template<> thread_local EvCellMemoryPool<4> EvCellMemoryPoolHolder<4>::Pool;
template<> thread_local EvCellMemoryPool<5> EvCellMemoryPoolHolder<5>::Pool;
template<> thread_local EvCellMemoryPool<6> EvCellMemoryPoolHolder<6>::Pool;
template<> thread_local EvCellMemoryPool<7> EvCellMemoryPoolHolder<7>::Pool;
template<> thread_local EvCellMemoryPool<8> EvCellMemoryPoolHolder<8>::Pool;
template<> thread_local EvCellMemoryPool<9> EvCellMemoryPoolHolder<9>::Pool;
template<> thread_local EvCellMemoryPool<10> EvCellMemoryPoolHolder<10>::Pool;
template<> thread_local EvCellMemoryPool<11> EvCellMemoryPoolHolder<11>::Pool;
template<> thread_local EvCellMemoryPool<12> EvCellMemoryPoolHolder<12>::Pool;
template<> thread_local EvCellMemoryPool<13> EvCellMemoryPoolHolder<13>::Pool;
template<> thread_local EvCellMemoryPool<14> EvCellMemoryPoolHolder<14>::Pool;
template<> thread_local EvCellMemoryPool<15> EvCellMemoryPoolHolder<15>::Pool;
template<> thread_local EvCellMemoryPool<16> EvCellMemoryPoolHolder<16>::Pool;
template<> thread_local EvCellMemoryPool<17> EvCellMemoryPoolHolder<17>::Pool;
template<> thread_local EvCellMemoryPool<18> EvCellMemoryPoolHolder<18>::Pool;
template<> thread_local EvCellMemoryPool<19> EvCellMemoryPoolHolder<19>::Pool;
template<> thread_local EvCellMemoryPool<20> EvCellMemoryPoolHolder<20>::Pool;
template<> thread_local EvCellMemoryPool<21> EvCellMemoryPoolHolder<21>::Pool;
#endif
#ifdef ENABLE_EXCEPTION_HANDLING_DISABLING
#endif
}   
namespace std {
class PtrToEvCell
{
public:
PtrToEvCell( WAFL_Evaluator::EvCell* ptr )
: Ptr_( ptr )
{}
~PtrToEvCell()
{
Ptr_->DeleteCell();
}
operator WAFL_Evaluator::EvCell*( )
{
return Ptr_;
}
WAFL_Evaluator::EvCell* Ptr_;
};
template<>
class shared_ptr<WAFL_Evaluator::EvCell> : shared_ptr<PtrToEvCell>
{
public:
shared_ptr( WAFL_Evaluator::EvCell* ptr )
: shared_ptr<PtrToEvCell>( new PtrToEvCell(ptr) )
{}
};
}
#endif  
namespace WAFL_ExternLib {
using fInternal = WAFL_Evaluator::fInternal;
using fInteger = WAFL_Evaluator::fInteger;
using fFloat = WAFL_Evaluator::fFloat;
using fBool = WAFL_Evaluator::fBool;
using EvCell = WAFL_Evaluator::EvCell;
using fString = sml::String;
using VersionNumber = sml::VersionNumber;
struct tLibClassData
{
const char*		ClassName;							
int				ClassID;							
void			(*ClassDestructor)( const void* );	
fString			(*ClassPrinter)( const void* );
const char*		ClassDescriptionStr = nullptr;
};
struct tLibFnData
{
const char*		FunctionName;
void			(*Function)( EvCell* result, const EvCell* args );
const char*		FunctionType;
const char*		FunctionDescriptionPtr = nullptr;
};
typedef bool( *tGlobalDestructorType )( void*, int );
struct tLibData
{
size_t				LibDataSize;		
const char*			LibraryName;		
size_t				NOfClasses;			
tLibClassData*		Classes;			
size_t				NOfFunctions;		
tLibFnData*			Functions;			
size_t				Build_WordSize;		
const char*			Build_Mode;			
VersionNumber		LibraryVersion;		
VersionNumber		UserVersion;		
};
typedef void( *tLibLibraryFunction )( EvCell* reserved, const EvCell* arguments );
struct tParentContextData
{
void( *CreateConstIntegerCellAt )( EvCell*, fInteger ) = nullptr;
void( *CreateConstFloatCellAt )( EvCell*, fFloat ) = nullptr;
void( *CreateConstBoolCellAt )( EvCell*, fBool ) = nullptr;
void( *CreateConstStringCellAt )( EvCell*, const char* ) = nullptr;
void( *CreateExternalObjectCellAt )( EvCell*, void*, const tLibClassData* ) = nullptr;
const void*( *GetObjectFromExternalObjectCell )( const EvCell* ) = nullptr;
};
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libExtern/../libCommon/libCommon.h
#ifndef SML_LibCommonH
#define SML_LibCommonH
namespace sml {}
// # # # included /home/smalkov/dev/Wafl/src/libCommon/Assert.h
#ifndef SML_Assert_H
#define SML_Assert_H
#ifndef NDEBUG
#define WAFL_ASSERT \
sml::LocalAssert(__LINE__,__FILE__)
#else
#define WAFL_ASSERT \
sml::NoAssert(__LINE__,__FILE__)
#endif
namespace sml {
struct LocalAssert
{
int line_;
const char* file_;
LocalAssert( int line=__LINE__, const char* file=__FILE__ )
: line_(line),
file_(file)
{}
void operator()( bool isOk, const char* msg=0 );
};
struct NoAssert
{
NoAssert( int line=__LINE__, const char* file=__FILE__ )
{}
void operator()( bool isOk, const char* msg=0 )
{}
};
} 
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libCommon/VariableSet.h
#ifndef SML_VariableSetH
#define SML_VariableSetH
#include <set>
#include <map>
namespace sml {
class VariableSet
{
public:
using tVarMap = std::map<String, String>;
using tVarSetName = std::set<String>;
VariableSet()
:	ParentVariableSet_( nullptr ),
Modified_( false )
{}
VariableSet( const tVarMap& vm )
: ParentVariableSet_( 0 ),
Modified_( false )
{
Variables_ = vm;
}
void operator=( const tVarMap& vm )
{
ParentVariableSet_ = 0;
Modified_ = false;
Variables_ = vm;
}
size_t Size() const;
void SetParent( VariableSet& parent )
{ ParentVariableSet_ = &parent; }
bool Get( const String& name, String& value ) const;
void Set( const String& name, const String& value )
{
_set( name, value );
setModified( true );
}
void Erase( const String& name )
{
_erase( name );
setModified( true );
}
void ClearLocals();
VariableSet* MakeUnion( const VariableSet& s ) const;
void Swap( VariableSet& vs );
void UpdateParentVariableSet();
void CopyAllVariablesFrom( const VariableSet& vs )
{
vs.CopyAllVariablesTo( LocalVars() );
}
void CopyAllVariablesTo( tVarMap& vm ) const
{
for( auto& i : *this )
vm.insert( i );
}
const tVarMap& LocalVars() const
{
return Variables_;
}
class const_iterator
{
public:
bool operator==( const const_iterator& it ) const
{ return variableSet == it.variableSet && iter == it.iter; }
bool operator!=( const const_iterator& it ) const
{ return !((*this)==it); }
const std::pair<const String,String>& operator*() const
{ return *iter; }
const std::pair<const String,String>* operator->() const
{ return &*iter; }
void operator++()
{
processed.insert( iter->first );
iter++;
processToCorrect();
}
void operator++(int)
{ operator++(); }
private:
const_iterator( const VariableSet& vset, bool beg=true );
void processToCorrect();
const VariableSet*		variableSet;
tVarMap::const_iterator	iter;
tVarSetName				processed;
friend class VariableSet;
};
const_iterator begin() const
{ return const_iterator( *this ); }
const_iterator end() const
{
return ParentVariableSet_
? ParentVariableSet_->end()
: const_iterator( *this, false );
}
protected:
VariableSet( const VariableSet& ) = delete;
VariableSet& operator = ( const VariableSet& ) = delete;
tVarMap& LocalVars()
{ return Variables_; }
void _set( const String& name, const String& value );
void _erase( const String& name );
bool isModified() const
{ return Modified_;}
void setModified( bool f = true )
{ Modified_ = f; }
VariableSet*	ParentVariableSet_;
tVarMap			Variables_;
tVarSetName     ToErase_;
bool            Modified_;
friend class const_iterator;
};
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libCommon/MessagesBase.h
#ifndef SML_MessagesBaseH
#define SML_MessagesBaseH
#include <map>
namespace sml {
class MessageLibrary
{
public:
struct MessageData;
static void RegisterMessages( int baseCode, const MessageData* data, unsigned n )
{ GetIt().AddMessages( baseCode, data, n ); }
static int RegisterMessages( const MessageData* data, unsigned n )
{ return GetIt().AddMessages( data, n ); }
static int UnregisterMessages()
{ return GetIt().ClearMessages(); }
static String GetMessage(
int msgCode,
const char* s1=0, const char* s2=0, const char* s3=0,
const char* s4=0, const char* s5=0, const char* s6=0
)
{ return GetIt().DoGetMessage(
msgCode,
s1, s2, s3, s4, s5, s6
);
}
~MessageLibrary();
private:
MessageLibrary()
: nextFreeDynamicMessageCode_(firstFreeDynamicMessageCode_),
libraryCount_(0)
{}
static MessageLibrary& GetIt();
void AddMessages( int baseCode, const MessageData* data, unsigned n );
int AddMessages( const MessageData* data, unsigned n );
int ClearMessages();
String DoGetMessage(
int msgCode,
const char* s1=0, const char* s2=0, const char* s3=0,
const char* s4=0, const char* s5=0, const char* s6=0
) const;
public:
enum class Language {
lngEnglish,
lngSerbian
};
struct MessageData
{
Language language;     
int msgCode;           
unsigned nOfParams;    
const char* msgText;   
};
private:
class Message
{
public:
Message( int code, const char* txt, unsigned nOfParams )
: msgCode_(code),
msgText_(txt),
nOfParams_(nOfParams)
{}
virtual ~Message()
{}
String GetMessage(
const char* s1=0,
const char* s2=0,
const char* s3=0,
const char* s4=0,
const char* s5=0,
const char* s6=0
) const;
private:
int				msgCode_;		
const char*		msgText_;		
unsigned		nOfParams_;		
};
class Messages : public std::map<int,Message*>
{
public:
virtual ~Messages()
{}
};
using AllMessages = std::map<Language,Messages*>;
private:
int					libraryCount_;
AllMessages			allMessages_;
int					nextFreeDynamicMessageCode_;
static const int	firstFreeDynamicMessageCode_ = 1000000;
};
class MessageCollection
{
public:
MessageCollection( int baseCode, MessageLibrary::MessageData* data, unsigned n )
: baseCode_( baseCode )
{ MessageLibrary::RegisterMessages( baseCode, data, n ); }
MessageCollection( MessageLibrary::MessageData* data, unsigned n )
: baseCode_( MessageLibrary::RegisterMessages( data, n ) )
{}
~MessageCollection()
{ MessageLibrary::UnregisterMessages(); }
String GetMessage(
int msgCode,
const char* s1=0,
const char* s2=0,
const char* s3=0,
const char* s4=0,
const char* s5=0,
const char* s6=0
) const
{
return MessageLibrary::GetMessage(
baseCode_ + msgCode,
s1, s2, s3, s4, s5, s6
);
}
int BaseCode() const
{ return baseCode_; }
private:
int baseCode_;
};
class MessageDepot
{
public:
virtual void AddMessage( const char* ) = 0;
static MessageDepot* Dummy();
};
class DummyMessageDepot : public MessageDepot
{
public:
void AddMessage( const char* ) override {}
};
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libCommon/SMException.h
#ifndef SML_ExceptionH
#define SML_ExceptionH
// # # # included /home/smalkov/dev/Wafl/src/libCommon/../libOs/SysErrors.h
#ifndef SMOSL_ErrorsH
#define SMOSL_ErrorsH
#include <string>
namespace smosl {
void SMMessageBox( const char* text, const char* caption, int flags );
class SMSysError
{
public:
static std::string GetErrorMessage( const std::string& head );
static std::string GetErrorMessage()
{ return GetErrorMessage( std::string() ); }
};
}   
#endif  
#include <vector>
namespace sml {
class SMException
{
public:
SMException( int msgCode, int subcode, const char* s1, const char* s2=0 );
explicit SMException( int msgCode, int subcode=-1 );
explicit SMException( const String& s1 );
explicit SMException( const char* s1 );
virtual ~SMException();
int Code() const
{ return Code_; }
int SubCode() const
{ return Subcode_; }
virtual const char* ClassName() const;
const String& DisplayText() const;
String ErrCodeText() const
{
return Subcode_ >= 0
? String( " [err " ) + Code_ + ":" + Subcode_ + "]"
: String( " [err " ) + Code_ + "]";
}
const SMException& Log() const;
const SMException& Log( const String& category ) const;
protected:
virtual void UpdateDisplayText() const
{
DisplayText_ = Message_ + ErrCodeText();
}
void SetDisplayText( const String& s ) const
{ DisplayText_ = s;  }
int					Code_;			
int					Subcode_;		
String				Message_;		
mutable String		DisplayText_;	
};
class SMExceptionSet : public SMException
{
public:
SMExceptionSet( int msgCode = 0, int subcode = -1, const char* s1 = 0, const char* s2 = 0 )
: sml::SMException( msgCode, subcode, s1, s2 )
{}
SMExceptionSet( SMExceptionSet& e )
: sml::SMException( e )
{
SubExceptions_ = std::move( e.SubExceptions_ );
e.SubExceptions_.clear();
}
~SMExceptionSet()
{
for( auto* e : SubExceptions_ )
delete e;
}
void AddSubException( SMException* exc )
{
SubExceptions_.push_back( exc );
}
protected:
void UpdateDisplayText() const override;
std::vector<SMException*> SubExceptions_;
};
}   
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libCommon/FileName.h
#ifndef SML_FileNameH
#define SML_FileNameH
// # # # included /home/smalkov/dev/Wafl/src/libCommon/../libOs/FileName.h
#ifndef SMOSL_FileNameH
#define SMOSL_FileNameH
// # # # included /home/smalkov/dev/Wafl/src/libOs/FileSystem.h
#ifndef SMOSL_FileSystemH
#define SMOSL_FileSystemH
#include <vector>
#include <string>
#include <chrono>
#include <sstream>
#include <cassert>
namespace smosl {
#if defined(WAFL_OS_LINUX)
using errno_t = int;
inline errno_t fopen_s( FILE** f, const char *filename, const char *mode ) {
assert( f );
*f = fopen( filename, mode );
return !(*f);
}
#endif
class FileName;
class FileSystem
{
public:
static constexpr char FilePathSeparator() {
#if defined(WAFL_OS_WINDOWS)
return '\\';
#else
return '/';
#endif
}
template<class tString>
static bool IsAbsolutePath( const tString& filename )
{ return IsAbsolutePath( filename.c_str() ); }
static bool IsAbsolutePath( const char* filename );
template<class tString>
static bool IsRelativePath( const tString& filename )
{ return IsRelativePath( filename.c_str() ); }
static bool IsRelativePath( const char* filename )
{ return !IsAbsolutePath( filename ); }
static std::string ReadFile( const FileName& filename );
static FileName GetModuleFilename();
static FileName GetUserHomePath();
static FileName GetUserAppDataPath();
static FileName GetCurrentWorkingDirectory();
static void SetCurrentWorkingDirectory( const FileName& dir );
template<class tString>
static bool FileExists( const tString& filename )
{ return FileExists( filename.c_str() ); }
static bool FileExists( const char* s );
template<class tString>
static bool DirExists( const tString& filename )
{ return DirExists( filename.c_str() ); }
static bool DirExists( const char* s );
template<class tString>
static bool FileOrDirExists( const tString& filename )
{ return FileOrDirExists( filename.c_str() ); }
static bool FileOrDirExists( const char* s );
template<class tString>
static size_t FileSize( const tString& filename )
{ return FileSize( filename.c_str() ); }
static size_t FileSize( const char* s );
template<class tString>
static bool FileDelete( const tString& filename )
{ return FileDelete( filename.c_str() ); }
static bool FileDelete( const char* s );
template<class tString>
static bool DirDelete( const tString& filename )
{ return DirDelete( filename.c_str() ); }
static bool DirDelete( const char* s );
template<class tString>
static bool DirCreate( const tString& filename )
{ return DirCreate( filename.c_str() ); }
static bool DirCreate( const char* s );
static bool DirCreateAll( const FileName& dirname );
template<class tString>
static bool GetLastFileModificationTime( const tString& filename, std::chrono::system_clock::time_point& tp )
{ return GetLastFileModificationTime( filename.c_str(), tp ); }
static bool GetLastFileModificationTime( const char* filename, std::chrono::system_clock::time_point& tp );
template<class tString>
static bool GetDirectories( const tString& filter, std::vector<FileName>& dirs )
{ return GetFilesDirectories( filter, dirs, false ); }
template<class tString1>
static bool GetFiles( const tString1& filter, std::vector<FileName>& files )
{ return GetFilesDirectories( filter, files, true ); }
static bool GetFilesDeep( const FileName& path, const std::string& filter, std::vector<FileName>& files );
static bool FindFileInPath(
const FileName& filename,
const std::vector<FileName>& paths,
FileName& foundFullFilename
);
static bool FindFileInPath(
const std::vector<FileName>& fnames,
const std::vector<FileName>& paths,
FileName& foundFullFilename
);
static FileName GetNewTempFileName( std::string prefix = "wafltmpfile_", std::string suffix = ".tmp" );
protected:
friend class FileName;
static bool GetFilesDirectories( const char* filter, std::vector<FileName>& dirs, bool getFiles=true );
template<class tString>
static bool GetFilesDirectories( const tString& filter, std::vector<FileName>& dirs, bool getFiles=true )
{ return GetFilesDirectories( filter.c_str(), dirs, getFiles ); }
static bool GetFilesDirectories_Imp( const char* filter, std::vector<FileName>& files, bool getFiles );
};
}   
#endif  
#include <algorithm>
namespace smosl {
class FileName
{
public:
FileName()
{}
FileName( const std::string& s )
: FileName_( s )
{ MakeCorrectSeparators(); }
FileName( const char* s )
: FileName_( s )
{ MakeCorrectSeparators(); }
FileName( const char* s, size_t n );
FileName( char c )
: FileName_( 1, c )
{ MakeCorrectSeparators(); }
std::string& str()
{ return FileName_; }
const std::string& str() const
{ return FileName_; }
const char* c_str() const
{ return FileName_.c_str(); }
bool operator == ( const FileName& f ) const
{ return str() == f.str(); }
template<class tString>
bool operator == ( const tString& x ) const
{ return str() == x; }
bool operator == ( const char* s ) const
{ return str() == s; }
bool operator != ( const FileName& f ) const
{ return str() != f.str(); }
template<class tString>
bool operator != ( const tString& x ) const
{ return str() != x; }
bool operator != ( const char* s ) const
{ return str() != s; }
bool operator < ( const FileName& f ) const
{ return str() < f.str(); }
template<class tString>
bool operator < ( const tString& x ) const
{ return str() < x; }
bool operator < ( const char* s ) const
{ return str() < s; }
bool empty() const
{ return FileName_.empty(); }
size_t size() const
{ return FileName_.size(); }
size_t length() const
{ return FileName_.length(); }
bool IsAbsolutePath() const
{ return FileSystem::IsAbsolutePath( c_str() ); }
bool IsRelativePath() const
{ return !IsAbsolutePath(); }
bool EndsWithASeparator() const
{ return FileName_.size() > 0 && FileName_[FileName_.size()-1] == FilePathSeparator(); }
bool BeginsWithASeparator() const
{ return FileName_.size() > 0 && FileName_[0] == FilePathSeparator(); }
bool ContainsPath() const
{return FileName_.find(FilePathSeparator()) != std::string::npos; }
bool ContainsOnlyPath() const
{ return ContainsPath() && EndsWithASeparator(); }
bool IsOnlyName() const
{ return !ContainsPath() && !empty(); }
static constexpr char FilePathSeparator()
{ return FileSystem::FilePathSeparator(); }
FileName& operator /= ( const FileName& filename );
FileName operator / ( const FileName& filename ) const
{
FileName result = *this;
return result /= filename;
}
FileName AddExtension( const std::string& ext ) const;
FileName GetPath() const
{ return PartLeftOfLastSepOrNothing( FilePathSeparator() ); }
FileName GetFileName() const
{ return PartRightOfLastSepOrAll( FilePathSeparator() ); }
std::string GetExtension() const
{ return GetFileName().PartRightOfLastSepOrNothing( '.' ).str(); }
bool FileExists() const
{ return FileSystem::FileExists( c_str() ); }
bool GetLastFileModificationTime( std::chrono::system_clock::time_point& tp ) const
{ return FileSystem::GetLastFileModificationTime( c_str(), tp ); }
static bool GetDirectories( const std::string& filter, std::vector<FileName>& dirs )
{ return FileSystem::GetDirectories( filter, dirs ); }
static bool GetFiles( const std::string& filter, std::vector<FileName>& files )
{ return FileSystem::GetFiles( filter, files ); }
static bool GetFilesDeep( const FileName& path, const std::string& filter, std::vector<FileName>& files )
{ return FileSystem::GetFilesDeep( path, filter, files ); }
static void ToLinuxPath( std::string& s )
{
#if defined(WAFL_OS_WINDOWS)
std::replace( s.begin(), s.end(), FilePathSeparator(), '/' );
#endif
}
private:
void MakeCorrectSeparators() {
#if defined(WAFL_OS_WINDOWS)
std::replace( FileName_.begin(), FileName_.end(), '/', FilePathSeparator() );
#endif
}
FileName PartLeftOfLastSepOrNothing( char sep ) const;
FileName PartRightOfLastSepOrAll( char sep ) const;
FileName PartRightOfLastSepOrNothing( char sep ) const;
std::string	FileName_;
};
}   
#endif  
namespace sml {
using smosl::FileName;
}
#endif  
// # # # included /home/smalkov/dev/Wafl/src/libCommon/FileSystem.h
#ifndef SML_FileSystemH
#define SML_FileSystemH
// # # # included /home/smalkov/dev/Wafl/src/libCommon/SMDateTime.h
#ifndef SML_DateTimeH
#define SML_DateTimeH
#include <chrono>
#include <cmath>
namespace sml {
class SMDateTimeDuration;
struct SMDateTime_Imp
{
SMDateTime_Imp()
: DatePart_(0),
TimePart_(0)
{}
SMDateTime_Imp(
unsigned short yy, unsigned short mm, unsigned short dd,
unsigned short h, unsigned short m, unsigned short s,
unsigned short ms
)
: DatePart_( MakeDatePart( yy, mm, dd ) ),
TimePart_( MakeTimePart( h, m, s, ms ) )
{}
SMDateTime_Imp( const std::chrono::system_clock::time_point& tp );
SMDateTime_Imp( struct tm& tblock, unsigned short ms );
SMDateTime_Imp(
short sign, unsigned long dd,
unsigned short h, unsigned short m, unsigned short s,
unsigned short ms
)
: DatePart_( MakeDurationDatePart( sign, dd ) ),
TimePart_( MakeTimePart( h, m, s, ms ) )
{}
static unsigned long MakeDatePart( unsigned short year, unsigned short month, unsigned short day );
static unsigned long MakeDurationDatePart( short sign, unsigned long days )
{
return ( sign < 0 ? durationSignMask : 0 )
| ( days & durationDaysMask );
}
static unsigned long MakeTimePart( unsigned short hour, unsigned short minute, unsigned short second, unsigned short ms )
{
return
hour << hourShift
| minute << minuteShift
| second << secondShift
| ms;
}
static bool IsLeapYear( int year );
static short DaysOfMonth( int month, int year );
static short DaysOfYear( int year )
{ return IsLeapYear( year ) ? short( 366 ) : short( 365 ); }
static short DaysToIncludingYear( int year )
{
unsigned y = abs( year );
int days = 365 * y + y / 4 - y / 100 + y / 400;
return year > 0
? days
: -days;
}
bool operator == ( const SMDateTime_Imp& dt ) const
{
return DatePart_ == dt.DatePart_
&& TimePart_ == dt.TimePart_;
}
bool operator < ( const SMDateTime_Imp& dt ) const
{
return
DatePart_ < dt.DatePart_
|| ( DatePart_ == dt.DatePart_ && TimePart_ < dt.TimePart_ );
}
bool HasDatePart() const
{ return DatePart_; }
bool HasTimePart() const
{ return TimePart_; }
unsigned short UnsignedYear() const
{ return (unsigned short)(( DatePart_ & yearMask ) >> yearShift ); }
short Year() const
{
int y = UnsignedYear();
if( y > 32767 )
y -= 65536;
return (short)y;
}
unsigned short Month() const
{ return (unsigned short)(( DatePart_ & monthMask ) >> monthShift ); }
unsigned short Day() const
{ return (unsigned short)( DatePart_ & dayMask ); }
unsigned short Hour() const
{ return (unsigned short)(( TimePart_ & hourMask ) >> hourShift ); }
unsigned short Minute() const
{ return (unsigned short)(( TimePart_ & minuteMask ) >> minuteShift ); }
unsigned short Second() const
{ return (unsigned short)(( TimePart_ & secondMask ) >> secondShift ); }
unsigned short Millisecond() const
{ return (unsigned short)( TimePart_ & msMask ); }
bool IsNegativeDuration() const
{ return DatePart_ & durationSignMask; }
unsigned long DurationDays() const
{ return (unsigned short)( DatePart_ & durationDaysMask ); }
unsigned long TimeToMs() const
{ return Millisecond() + 1000 * ( Second() + 60 * ( Minute() + 60 * Hour() ) ); }
long DateToDays() const;
void SetDatePart( short year, short month, short day )
{ DatePart_ = MakeDatePart( year, month, day ); }
void SetDatePartUsingDays( long days );
void SetDurationDatePart( short sign, unsigned long days )
{ DatePart_ = MakeDurationDatePart( sign, days ); }
void SetDuration( short sign, unsigned long days, unsigned long ms )
{
SetDurationDatePart( sign, days );
SetTimePartUsingMs( ms );
}
void SetDuration( short sign, unsigned long days, unsigned short h, unsigned short m, unsigned short s, unsigned short ms )
{
SetDurationDatePart( sign, days );
SetTimePart( h, m, s, ms );
}
void SetTimePart( unsigned short hour, unsigned short minute, unsigned short second, unsigned short ms)
{ TimePart_ = MakeTimePart( hour, minute, second, ms ); }
void SetTimePartUsingMs( unsigned long ms );
unsigned long DatePart_;		
unsigned long TimePart_;		
enum {
durationSignMask = 0x80000000,		
durationDaysMask = 0x7fffffff,		
yearMask =		0xfffff800,		
yearShift =		11,
monthMask =		0x000007c0,		
monthShift =	6,
dayMask =		0x0000003f,		
zeroDate =		0x00000041,		
hourMask =		0xfe000000,		
hourShift =		25,
minuteMask =	0x01fc0000,		
minuteShift =	18,
secondMask =	0x0003f800,		
secondShift =	11,
msMask =		0x000007ff		
};
};
class SMDateTime
{
public:
SMDateTime(
unsigned short yy, unsigned short mm, unsigned short dd,
unsigned short h, unsigned short m, unsigned short s,
unsigned short ms = 0
)
: Data_( yy, mm, dd, h, m, s, ms )
{}
SMDateTime()
: SMDateTime( 0, 0, 0, 0, 0, 0, 0 )
{}
SMDateTime( unsigned short y, unsigned short m, unsigned short d )
: SMDateTime( y, m, d, 0, 0, 0, 0 )
{}
SMDateTime( unsigned short h, unsigned short m, unsigned short s, unsigned short ms )
: SMDateTime( 0, 0, 0, h, m, s, ms )
{}
SMDateTime( struct tm& tblock, unsigned short ms=0 )
: Data_( tblock, ms )
{}
SMDateTime( const std::chrono::system_clock::time_point& tp )
: Data_( tp )
{}
static SMDateTime CurrentDateTime();
static SMDateTime CurrentDate();
static SMDateTime CurrentTime();
static bool IsLeapYear( int year )
{ return SMDateTime_Imp::IsLeapYear( year ); }
static short DaysOfMonth( int month, int year )
{ return SMDateTime_Imp::DaysOfMonth( month, year ); }
bool IsLeapYear() const
{ return IsLeapYear( Year() ); }
unsigned short DaysOfMonth() const
{ return DaysOfMonth( Month(), Year() ); }
bool operator == ( const SMDateTime& dt ) const
{ return Data_ == dt.Data_; }
bool operator < ( const SMDateTime& dt ) const
{ return Data_ < dt.Data_; }
SMDateTime& operator += ( const SMDateTimeDuration& dtd );
SMDateTime& operator -= ( const SMDateTimeDuration& dtd );
SMDateTime operator + ( const SMDateTimeDuration& dtd ) const
{
SMDateTime r( *this );
r += dtd;
return r;
}
SMDateTime operator - ( const SMDateTimeDuration& dtd ) const
{
SMDateTime r( *this );
r -= dtd;
return r;
}
SMDateTimeDuration operator - ( const SMDateTime& dt ) const;
bool HasDatePart() const
{ return Data_.HasDatePart(); }
bool HasTimePart() const
{ return Data_.HasTimePart(); }
short Year() const
{ return Data_.Year(); }
unsigned short Month() const
{ return Data_.Month(); }
unsigned short Day() const
{ return Data_.Day(); }
unsigned short Hour() const
{ return Data_.Hour(); }
unsigned short Minute() const
{ return Data_.Minute(); }
unsigned short Second() const
{ return Data_.Second(); }
unsigned short Millisecond() const
{ return Data_.Millisecond(); }
long TimeToMs() const
{ return Data_.TimeToMs(); }
long DateToDays() const
{ return Data_.DateToDays(); }
private:
SMDateTime_Imp		Data_;
};
class SMDateTimeDuration
{
public:
SMDateTimeDuration(
short sign, unsigned long dd,
unsigned short h, unsigned short m, unsigned short s,
unsigned short ms = 0
)
: Data_( sign, dd, h, m, s, ms )
{}
SMDateTimeDuration()
: SMDateTimeDuration( 0, 0, 0, 0, 0 )
{}
SMDateTimeDuration( unsigned short h, unsigned short m, unsigned short s, unsigned short ms )
: SMDateTimeDuration( 0, 0, h, m, s, ms )
{}
SMDateTimeDuration( short sign, unsigned long days, unsigned long ms=0 )
{
Data_.SetTimePartUsingMs( ms );
Data_.SetDurationDatePart( sign, days );
}
bool operator == ( const SMDateTimeDuration& dt ) const
{ return Data_ == dt.Data_; }
bool operator < ( const SMDateTimeDuration& dt ) const
{ return Data_ < dt.Data_; }
SMDateTimeDuration& operator += ( const SMDateTimeDuration& dtd );
SMDateTimeDuration operator + ( const SMDateTimeDuration& dtd ) const
{
SMDateTimeDuration r( *this );
r += dtd;
return r;
}
SMDateTimeDuration& operator -= ( const SMDateTimeDuration& dtd )
{ return ( *this ) += -dtd; }
SMDateTimeDuration operator - ( const SMDateTimeDuration& dtd ) const
{ return ( *this ) + -dtd; }
SMDateTimeDuration operator - () const
{ return SMDateTimeDuration( -Sign(), Days(), Hour(), Minute(), Second(), Millisecond() ); }
bool HasDatePart() const
{ return Data_.HasDatePart(); }
bool HasTimePart() const
{ return Data_.HasTimePart(); }
bool IsNegative() const
{ return Data_.IsNegativeDuration(); }
short Sign() const
{ return IsNegative() ? -1 : 1; }
unsigned long Days() const
{ return Data_.DurationDays(); }
long SignedDays() const
{ return Sign() * Days(); }
unsigned short Hour() const
{ return Data_.Hour(); }
short SignedHour() const
{ return Sign() * Hour(); }
unsigned short Minute() const
{ return Data_.Minute(); }
short SignedMinute() const
{ return Sign() * Minute(); }
unsigned short Second() const
{ return Data_.Second(); }
short SignedSecond() const
{ return Sign() * Second(); }
unsigned short Millisecond() const
{ return Data_.Millisecond(); }
short SignedMillisecond() const
{ return Sign() * Millisecond(); }
long TimeToMs() const
{ return Millisecond() + 1000 * ( Second() + 60 * ( Minute() + 60 * Hour() ) ); }
long TimeToSignedMs() const
{ return Sign() * TimeToMs(); }
private:
SMDateTime_Imp		Data_;
};
}   
#endif  
namespace sml {
class FileSystem : public smosl::FileSystem
{
public:
static bool GetLastFileModificationTime( const FileName& filename, SMDateTime& dt );
};
}   
#endif  
#endif  
